//-------------------------------------------------------------------------
// Based on the source reversed from MH 5.1s sting-edited version
// 2003- sting - stingxp@yahoo.com
//
// The part for localization support based on d2locale plugin for v1.09d
// Authors(Battlecn.net ID): 
//......
//Neo
//Kant
//-------------------------------------------------------------------------

//Mousepad's Diablo II Maphack v4.6c (v1.09d)
//Derivative works to be distributed for free with full source and full credits (ie dont blame me)
//?2001-2 mousepad - mousepad@forward.to


#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include <wchar.h>
#include <math.h>
#include "d2structs.h"
#include "hackmap.h"

#define ENABLE_CATCH_EXECEPTION

#ifdef ENABLE_CATCH_EXECEPTION
#include "exception.cxx"
#endif

#include "crc.cxx"


char *szProgTitle = "Sting's Diablo II Hackmap v1.11b (v2.24)";
void KeepGameWindow();


#include "d2ptrs.cxx"
#include "d2callstub.cxx"
#include "d2helpers.cxx"
#include "hnmtoggles.cxx"

void __cdecl DEBUGMSG(char *fmt, ...)
{
	char szBuffer[1024];
	va_list ap;
	va_start(ap, fmt);
	vsprintf(szBuffer, fmt, ap);
	OutputDebugStringA(szBuffer);
	va_end(ap);
}

struct I386Registers
{
	DWORD edi;
	DWORD esi;
	DWORD ebp;
	DWORD esp;
	DWORD ebx;
	DWORD edx;
	DWORD ecx;
	DWORD eax;
};

MyAutomapLayerMan apMyAutomapLayer[100];
void AddMyAutomapCell(AutomapCell *cell)
{
	MyAutomapLayerMan *pMyLayerMan = &apMyAutomapLayer[D2CLIENT_pAutomapLayer->nLayerNo];
	MyAutomapLayer **ppMyLayer = &pMyLayerMan->pMyLayer;
	while (*ppMyLayer && (*ppMyLayer)->pNextChunk)
		ppMyLayer = &(*ppMyLayer)->pNextChunk;
	if (*ppMyLayer && pMyLayerMan->wCellNodeNum < MYCELL_CHUNK_NUM) {
		(*ppMyLayer)->aMyCell[pMyLayerMan->wCellNodeNum].nCellNo = cell->nCellNo;
		(*ppMyLayer)->aMyCell[pMyLayerMan->wCellNodeNum].xPixel = cell->xPixel;
		(*ppMyLayer)->aMyCell[pMyLayerMan->wCellNodeNum].yPixel = cell->yPixel;
		pMyLayerMan->wCellNodeNum++;
	}
	else {
		if (*ppMyLayer)
			ppMyLayer = &(*ppMyLayer)->pNextChunk;
		*ppMyLayer = new MyAutomapLayer;
		memset(*ppMyLayer, 0, sizeof(MyAutomapLayer));
		pMyLayerMan->wCellChunkNum++;
		(*ppMyLayer)->aMyCell[0].nCellNo = cell->nCellNo;
		(*ppMyLayer)->aMyCell[0].xPixel = cell->xPixel;
		(*ppMyLayer)->aMyCell[0].yPixel = cell->yPixel;
		pMyLayerMan->wCellNodeNum = 1;
	}
}

MyAutomapCell* GetMyAutomapCell(int index)
{
	MyAutomapLayerMan *pMyLayerMan = &apMyAutomapLayer[D2CLIENT_pAutomapLayer->nLayerNo];
	int chunk_num = index/MYCELL_CHUNK_NUM;
	int idx = index%MYCELL_CHUNK_NUM;
	MyAutomapLayer *pMyLayer = pMyLayerMan->pMyLayer;
	for (int j = 0; pMyLayer && j < chunk_num; j++)
		pMyLayer = pMyLayer->pNextChunk;
	return pMyLayer ? &pMyLayer->aMyCell[idx] : NULL;
}

void DestroyMyAutomapCells()
{
	for (int i = 0; i < ARRAYSIZE(apMyAutomapLayer); i++) {
		MyAutomapLayer *pMyLayer = apMyAutomapLayer[i].pMyLayer;
		while(pMyLayer) {
			MyAutomapLayer *pTemp = pMyLayer->pNextChunk;
			delete pMyLayer;
			pMyLayer = pTemp;
		}
	}
	memset(apMyAutomapLayer, 0, sizeof(apMyAutomapLayer));
}

//automap stuff
AutomapLayer* InitAutomapLayer(DWORD levelno)
{
	AutomapLayer2 *pLayer = D2COMMON_GetDrlgLayer(levelno);
	return D2CLIENT_InitAutomapLayer(pLayer->nLayerNo);
}


DWORD GetPresetUnitObjCell(DWORD objno, DWORD levelno)
{
	if (objno == 397) return 318; //chests
	if (objno == 371) return 301;//318; //countess chest
	if (objno == 152) return 300; //orifice
	if (objno == 460) return 1468; //drehya = frozen anya
	if ((objno == 402) && (levelno == 46)) return 0; //canyon/arcane waypoint
	if ((objno == 267) && (levelno != 75) && (levelno != 103)) return 0; //bank not act3,4 town
	if ((objno == 376) && (levelno == 107)) return 376; // hell forge

	//FIXME
	if (objno >= 574) { //random
		static WORD rndobjcells[9] = { //rnd obj no, new obj no, shrine min, shrine max (not inclusive)
			CELLNO_MYSHRINES+0,  //574 = 310 (shrine), 2,  6
			CELLNO_MYSHRINES+7,  //575 = 310 (shrine), 7,  7
			CELLNO_MYSHRINES+0,  //576 = 310 (shrine), 8,  11
			CELLNO_MYSHRINES+12, //575 = 310 (shrine), 12, 12
			CELLNO_MYSHRINES+0,  //578 = 310 (shrine), 1,  5
			CELLNO_MYSHRINES+14, //579 = 310 (shrine), 14, 14
			0, //580 = chest
			0, //581 = chest
			0, //582 = arcane symbol
		};
		return rndobjcells[objno-574];
	}
	ObjectTxt *obj = D2COMMON_GetObjectTxt(objno);
	DWORD cellno = obj->nAutoMap;
	if (cellno == CELLNO_SHRINE) {
		static WORD parm0cells[4] = {
			CELLNO_MYSHRINES+0, //0 = ??
			CELLNO_MYSHRINES+2, //1 = health
			CELLNO_MYSHRINES+3, //2 = mana
			CELLNO_MYSHRINES+0, //3 = magic
		};
		cellno = (obj->nSubClass & 1) ? parm0cells[obj->nParm0] : 0;
	}
	return cellno;
}

DrlgRoom2 *GetRoomTileOtherRoom2(DrlgRoom2 *room2, DWORD roomtileno)
{
	RoomTile *roomtile = room2->pRoomTiles;
	while (roomtile) {
		if (*roomtile->nNum == roomtileno) {
			return roomtile->pRoom2;
		}
		roomtile = roomtile->pNext;
	}
	return 0;
}


void AddMinimapCell(AutomapCell *cell, DrlgLevel *pDrlgLevel);
void AddAutomapRoomCell(int xpos, int ypos, int cellno, DrlgRoom2 *room2, int xoffset = 0, int yoffset = 0)
{
	if (cellno == 376 && room2->pDrlgLevel->nLevelNo == 107) { // hell forge
		AutomapCell cell;
		cell.nCellNo = cellno;
		xpos = (room2->xPos*5)+xpos;
		ypos = (room2->yPos*5)+ypos;
		cell.xPixel = (((xpos-ypos)*16)/10)+1+xoffset;
		cell.yPixel = (((ypos+xpos)*8)/10)-3+yoffset;
		AddMinimapCell(&cell, room2->pDrlgLevel);
	}
	else {
		AutomapCell *cell = D2CLIENT_NewAutomapCell();

		cell->nCellNo = cellno;
		xpos = (room2->xPos*5)+xpos;
		ypos = (room2->yPos*5)+ypos;
		cell->xPixel = (((xpos-ypos)*16)/10)+1+xoffset;
		cell->yPixel = (((ypos+xpos)*8)/10)-3+yoffset;
		D2CLIENT_AddAutomapCell(cell, &D2CLIENT_pAutomapLayer->pObjects);

		AddMyAutomapCell(cell);
		AddMinimapCell(cell, room2->pDrlgLevel);
	}
}

void __stdcall FilterOutMyAutomapCells(AutomapCell *cell)
{
	if (cell) {
		FilterOutMyAutomapCells(cell->pLess);
		if (cell->nCellNo >= CELLNO_MYSHRINES && cell->nCellNo < CELLNO_MYSHRINES+23) {
//			cell->nCellNo = CELLNO_MYSHRINES;
			cell->fSaved = 1;
		} else if ((short)cell->nCellNo < 0) {
			cell->fSaved = 1;
		}
		FilterOutMyAutomapCells(cell->pMore);
	}
}

void LoadMyAutomapLayer()
{
	MyAutomapCell *pMyCell;
	for (int i = 0; (pMyCell = GetMyAutomapCell(i)) != NULL; i++) {
		AutomapCell *cell = D2CLIENT_NewAutomapCell();
		cell->nCellNo = pMyCell->nCellNo;
		cell->xPixel = pMyCell->xPixel;
		cell->yPixel = pMyCell->yPixel;
		D2CLIENT_AddAutomapCell(cell, &D2CLIENT_pAutomapLayer->pObjects);
	}
}

void __declspec(naked) SaveAutomapLayerToFilePatch_ASM()
{
	__asm {
		mov eax, [p_D2CLIENT_pAutomapLayer];
		mov eax, [eax];
		test eax, eax;
		jz retfunc;
		push eax;
		mov eax, [eax]AutomapLayer.pObjects;
		push eax;
		call FilterOutMyAutomapCells;
		pop eax;
retfunc:
		ret;
	}
}

void __declspec(naked) LoadAutomapLayerFromFilePatch_ASM()
{
	__asm {
		pop eax;
		push LoadMyAutomapLayer;
		push ebp;
		mov ebp, esp;
		and esp, 0xFFFFFFF8;
		jmp eax;
	}
}

void DoRemoveMyAutomapCell(AutomapCell* cell)
{
	if (cell->nCellNo >= CELLNO_MYSHRINES && cell->nCellNo < CELLNO_MYSHRINES+23) {
		cell->nCellNo = CELLNO_SHRINE;
	} else if ((short)cell->nCellNo < 0) {
		cell->nCellNo = 0;
	}
}

void NextRemoveMyAutomapCell(AutomapCell* cell)
{
	if (cell) {
		NextRemoveMyAutomapCell(cell->pLess);
		DoRemoveMyAutomapCell(cell);
		NextRemoveMyAutomapCell(cell->pMore);
	}
}

void RemoveMyAutomapCells()
{
	NextRemoveMyAutomapCell(D2CLIENT_pAutomapLayer->pObjects);
	return;
	for (AutomapLayer *pAutomapLayer = D2CLIENT_pAutomapLayerListHdr; pAutomapLayer != NULL; pAutomapLayer = pAutomapLayer->pNextLayer) {
		NextRemoveMyAutomapCell(pAutomapLayer->pObjects);
	}
}

void RevealAutomapRoom2(DrlgRoom2 *room2)
{
	D2CLIENT_RevealAutomapRoom(room2->pRoom1, 1, D2CLIENT_pAutomapLayer);

	PresetUnit *unit = room2->pPresetUnits;
	while (unit) {
		int cellno = 0, xoffset = 0, yoffset = 0;
		switch (unit->nUnitType) {
			case UNITNO_MONSTER:
				if (unit->nTxtFileNo == 256) cellno = 300; //izual
				else if (unit->nTxtFileNo == 745) cellno = unit->nTxtFileNo; //Hephasto The Armorer at Hell Forge
				break;

			case UNITNO_OBJECT:
				cellno = GetPresetUnitObjCell(unit->nTxtFileNo, room2->pDrlgLevel->nLevelNo);
				break;

			case UNITNO_ROOMTILE:
				DrlgRoom2 *otherroom2 = GetRoomTileOtherRoom2(room2, unit->nTxtFileNo);
				if (otherroom2) {
					//change pos here because better for minimap
					cellno = -(int)(otherroom2->pDrlgLevel->nLevelNo);
					xoffset = +8;
					yoffset = -28;
				}
				break;
		}
		if (cellno) {
			AddAutomapRoomCell(unit->xPos, unit->yPos, cellno, room2, xoffset, yoffset);
		}
		unit = unit->pNext;
	}
}

void RevealAutomapRoom(DrlgRoom2 *room2)
{
	if (room2->nPresetType == 2) {
		DWORD presetno = *room2->nPresetType2No;
		if (presetno >= 38 && presetno <= 39) return; //Act 1 - Swamp Fill 1&2
		if (presetno >= 401 && presetno <= 405) return; //Act 2 - Desert Fill Bone 1&2, Desert Fill Wagon 1, Desert Fill Berms 1&2
		if (presetno == 836) return; //Act 4 - Lava X
		if (presetno == 863) return; //Act 5 - Town
	}
	if (room2->pRoom1) {
		RevealAutomapRoom2(room2);
	} else {
		BYTE cmdbuf[6];
		*(WORD *)(cmdbuf+1) = (WORD)room2->xPos;
		*(WORD *)(cmdbuf+3) = (WORD)room2->yPos;
		cmdbuf[5] = (BYTE)room2->pDrlgLevel->nLevelNo;
		D2CLIENT_RecvCommand07(cmdbuf);
		RevealAutomapRoom2(room2);
		D2CLIENT_RecvCommand08(cmdbuf);
	}
}

void RevealAutomapLevel(DrlgLevel *pDrlgLevel)
{
	DrlgRoom2 *currroom = pDrlgLevel->pRoom2First;
	while (currroom) {
		RevealAutomapRoom(currroom);
		currroom = currroom->pNext;
	}
}

DrlgLevel *GetUnitDrlgLevel(UnitAny *unit)
{
	if (unit && unit->pPos->pRoom1) {
		return unit->pPos->pRoom1->pRoom2->pDrlgLevel;
	}
	return NULL;
}

void RevealAutomapLevel()
{
	RevealAutomapLevel(GetUnitDrlgLevel(D2CLIENT_GetPlayerUnit()));
}

static BYTE actlvls[] = {1, 40, 75, 103, 109, 133};
DWORD GetCurrentAct(DrlgLevel* currlvl)
{
	if (!currlvl) return 0;

	DWORD l = currlvl->nLevelNo;
	DWORD act = 0;
	do {} while (l >= actlvls[++act]);
	return act;
}
BYTE afRevealedActs[16];

#if 0
void FindStruct(LPVOID lpv)
{
	DWORD target = 2;//(DWORD)reinterpret_cast<DrlgRoom2*>(lpv);
	LPDWORD pdw = (LPDWORD)lpv;
	for(int i = 0; i < 0x1000; i++)
	{
		if (!IsBadReadPtr((LPVOID)pdw[i], 4))
		{
			PDWORD pdw2 = (PDWORD)pdw[i];
			__try {
				if (DWORD(reinterpret_cast<PresetUnit*>(pdw[i])->nUnitType) == target
				&&	DWORD(reinterpret_cast<PresetUnit*>(pdw[i])->nTxtFileNo != 0))
					__asm int 3;
				//for (int j = 0; j < 0x1000; j++)
				//{
				//	if (pdw2[j] == target)
				//		__asm int 3;
				//}
			} __except(EXCEPTION_EXECUTE_HANDLER) {
			}
		}
	}
}
#endif

DrlgLevel* __fastcall GetDrlgLevel(DrlgMisc *drlgmisc, DWORD levelno)
{
	for (DrlgLevel* pDrlgLevel = drlgmisc->pLevelFirst; pDrlgLevel; pDrlgLevel = pDrlgLevel->pLevelNext)
	{
		if (pDrlgLevel->nLevelNo == levelno)
			return pDrlgLevel;
	}
	return D2COMMON_GetDrlgLevel(drlgmisc, levelno);
}

void RevealAutomapAct()
{
	DWORD currlvl = GetUnitDrlgLevel(D2CLIENT_GetPlayerUnit())->nLevelNo;
	if (currlvl >= actlvls[ARRAYSIZE(actlvls)-1]) {
		int eindex = ARRAYSIZE(actlvls)+(currlvl-actlvls[ARRAYSIZE(actlvls)-1]);
		if (afRevealedActs[eindex] == 0) {
			RevealAutomapLevel();
			afRevealedActs[eindex] = 1;
		}
		return;
	}

	DWORD act = 0;
	do {} while (currlvl >= actlvls[++act]);

	if (afRevealedActs[act-1])
		return;
	
	for (DWORD lvl = actlvls[act-1]; lvl < actlvls[act]; lvl++) {
		DrlgLevel *pDrlgLevel = GetDrlgLevel(D2CLIENT_pDrlgAct->pDrlgMisc, lvl);
		if (!pDrlgLevel) break;
		if (!pDrlgLevel->pRoom2First) {
			D2COMMON_InitDrlgLevel(pDrlgLevel);
		}
		InitAutomapLayer(lvl);
		RevealAutomapLevel(pDrlgLevel);
	}

	InitAutomapLayer(currlvl);
	afRevealedActs[act-1] = 1;
}

void __fastcall OverrideShrinePatch(AutomapCell *newnode, AutomapCell *currnode)
{
	if ((newnode->nCellNo < CELLNO_MYSHRINES) || (newnode->nCellNo >= (CELLNO_MYSHRINES+NUMOF_SHRINES))) return;
	if (currnode->nCellNo >= newnode->nCellNo) return;
	currnode->fSaved = newnode->fSaved;
	currnode->nCellNo = newnode->nCellNo;
}

void __declspec(naked) OverrideShrinePatch_ASM()
{
	__asm {
//esi = ptr curr node
//ecx = ptr new node
		pushad
		mov edx,esi
		call OverrideShrinePatch
		popad
//original code
		mov edx,D2CLIENT_OverrideShrinePatch_ORIG
		mov edx,[4*eax+edx]
		ret
	}
}

//shrines stuff

CellFile *apMyShrineCells[2][NUMOF_SHRINES];
CellFile *pWaypointCell;
CellFile *pMinimapObjectCell;
void InitShrines()
{
	char filename[MAX_PATH];
	for (int i = 0; i < 2; i++) {
		for (int j = 0; j < NUMOF_SHRINES; j++) {
			wsprintf(GetMyFileNameStrrchr(filename, '\\'), "MINISHRINE%.2d.BMP"+(i?0:4), j);
			apMyShrineCells[i][j] = InitCellFile(LoadBmpCellFile(filename));
		}
	}
	wsprintf(GetMyFileNameStrrchr(filename, '\\'), "WAYPOINT.BMP");
	pWaypointCell = InitCellFile(LoadBmpCellFile(filename));
	wsprintf(GetMyFileNameStrrchr(filename, '\\'), "BLOBCELL.BMP");
	pMinimapObjectCell = InitCellFile(LoadBmpCellFile(filename));
	if(!pMinimapObjectCell) {
		wsprintf(GetMyFileNameStrrchr(filename, '\\'), "BLOBDOT.BMP");
		pMinimapObjectCell = InitCellFile(LoadBmpCellFile(filename));
	}
}

void DeleteShrines()
{
	for (int i = 0; i < 2; i++) {
		for (int j = 0; j < NUMOF_SHRINES; j++) {
			DeleteCellFile(apMyShrineCells[i][j]);
		}
	}
	DeleteCellFile(pWaypointCell);
	DeleteCellFile(pMinimapObjectCell);
}

void __declspec(naked) AddShrinePatch_ASM()
{
	__asm {
// 1.10
//esi = ptr unit object
//edi = ptr object.txt
//return edx = cell no

// 1.11
//ebx = ptr unit object
//esi = ptr object.txt
//return ecx = cell no

//		mov ecx,[esi]ObjectTxt.nAutoMap //original code
		mov ecx,[esi+0x1BC]
		cmp ecx,CELLNO_SHRINE
		jne notshrine
		xor ecx,ecx
//		test [esi]ObjectTxt.nSubClass,1
		test [esi+0x166],1
		je notshrine
//		mov eax,[ebx]UnitAny.pObjectData
		mov eax,[ebx+0x14]
		movzx ecx,[eax]ObjectData.nShrineNo
		add ecx,CELLNO_MYSHRINES
notshrine:
		ret
	}
}

//draw automap cave names/shrines

BYTE nCaveNameTextCol = 0;

BYTE *szStaffTombLvlDesc;

void DrawAutomapCellHint(int cellno, DWORD xpos, DWORD ypos);

void __stdcall DrawAutomapCellPatch(CellContext *pCellContext, DWORD xpos, DWORD ypos, RECT *cliprect, DWORD bright)
{
	int cellno = pCellContext->nCellNo;

#ifdef DUMP_CELLNO
	if(cellno)
	{
		char szLevelName[1024];
		LevelTxt* lt = D2COMMON_GetLevelTxt(cellno ? cellno : -cellno);
		if(!lt)
		{
			sprintf(szLevelName, "cellno = %d\n", cellno ? cellno : -cellno);
			OutputDebugString(szLevelName);
		}
	}
#endif

	if (cellno < 0) {
		if (tToggleAutomapLevelNames.flag) {
			wchar_t temp[1024];
			wcscpy(temp, D2COMMON_GetLevelTxt(-cellno)->szName);
			if (szStaffTombLvlDesc && (-cellno == (int)D2CLIENT_pDrlgAct->pDrlgMisc->nStaffTombLvl))
				ConvertToD2String(temp+wcslen(temp), szStaffTombLvlDesc, 0, &temp[ARRAYSIZE(temp)-1]);
			D2DrawCenterText(6, temp, xpos, ypos, (nCaveNameTextCol > 12) ? 0 : nCaveNameTextCol);
		}
		return;
	}
	if (cellno == CELLNO_WAYPOINT && pWaypointCell != 0)
	{
		pCellContext->nCellNo = 0;
		pCellContext->pCellFile = pWaypointCell;
		xpos += (D2CLIENT_GetAutomapSize() ? 4 : 8)-(pWaypointCell->cells[0]->width/2);
		ypos += (D2CLIENT_GetAutomapSize() ? 4 : 0);
	}
	if (((cellno -= CELLNO_MYSHRINES) >= 0) && (cellno < NUMOF_SHRINES)) {
		CellFile *myshrine = apMyShrineCells[D2CLIENT_GetAutomapSize() & tToggleMiniShrine.flag][cellno];
		if (myshrine) {
			pCellContext->pCellFile = myshrine;
			pCellContext->nCellNo = 0;
			xpos += (D2CLIENT_GetAutomapSize() ? 4 : 8)-(myshrine->cells[0]->width/2);
		} else {
			pCellContext->nCellNo = CELLNO_SHRINE;
		}
	}
	D2GFX_DrawAutomapCell(pCellContext, xpos, ypos, cliprect, bright);
}

//visuals stuff

void __declspec(naked) WeatherPatch_ASM()
{
	__asm {
		cmp [tToggleFullVisuals.flag],0
		je rainold
		xor al,al
rainold:
		ret 0x04
	}
}

void __declspec(naked) LosDrawPatch_ASM()
{
	__asm {
		cmp [tToggleFullVisuals.flag],0
		je losdrawold
		xor eax,eax
losdrawold:
		ret 0x04
	}
}

void __declspec(naked) LightingPatch_ASM()
{
	__asm {
//[esp+4+0] = ptr red
//[esp+4+1] = ptr green
//[esp+4+2] = ptr blue
//return eax = intensity
		cmp [tToggleFullVisuals.flag],0
		je lightold

		mov eax,0xff
		mov byte ptr [esp+4+0], al
		mov byte ptr [esp+4+1], al
		mov byte ptr [esp+4+2], al
		add dword ptr [esp], 0x72;
		ret
lightold:
//original code
		push esi
		call D2COMMON_GetLevelIdFromRoom
		ret
	}
}

//map scroll stuff (also visuals shake)

int xMapOffset = 0, yMapOffset = 0;

BYTE nMapScrollSpeed = 8;

void __stdcall ShakeScreenPatch(DWORD *xpos, DWORD *ypos)
{
	D2CLIENT_CalcShake(xpos, ypos);
	if (tToggleScreenshake.flag) {
		D2CLIENT_xMapShake = 0;
		D2CLIENT_yMapShake = 0;
	}
	if (tToggleScrollMap.flag) {
		D2CLIENT_xMapShake += xMapOffset;
		D2CLIENT_yMapShake += yMapOffset;
	}

	*xpos += D2CLIENT_xMapShake;
	*ypos += D2CLIENT_yMapShake;
}

void ScrollMap(char xinc, char yinc)
{
	if (tToggleScrollMap.flag) {
		xMapOffset += xinc*nMapScrollSpeed;
		yMapOffset += yinc*nMapScrollSpeed;
	} else if (D2CLIENT_fAutomapOn) {
		D2CLIENT_ptAutomap.x += xinc*8;
		D2CLIENT_ptAutomap.y += yinc*8;
	}
}

void CenterMap()
{
	xMapOffset = 0;
	yMapOffset = 0;
}

//lifebar stuff

BYTE nLifeBarTrans = -1, nLifeBarColour = -1;


void __declspec(naked) LifeBarPatch_ASM()
{
	__asm {
		pop eax
//originalish code
		movzx edx,[nLifeBarTrans]
		cmp dl,-1
		jne nodefault1
		mov dl,1
nodefault1:
		push edx
		mov dl,[nLifeBarColour]
		cmp dl,-1
		jne nodefault2
		mov dl,5
nodefault2:
		push edx
		sar edi,7
		jmp eax
	}
}

//shared item vars

char nQuestItemColour = -1;
char nUnk1ItemColour = 1;
int nItemValueNpc = 0x201;
char nMonsterColor = -1;
typedef char ItemColours[8][2][7][2];

static union {
	ItemColours anItemColours[3000];
	struct {
		ItemColours anItemWeaponCols[1000];
		ItemColours anItemArmorCols[1000];
		ItemColours anItemMiscCols[1000];
	};
};

char anRuneColours[100][2];

int nGoldGoodNum = 0; char nGoldGoodCol[2] = {-1,-1}, nGoldPoorCol[2] = {-1,-1};

void InitItemColours()
{
}

int GetItemColourIndex(int pos)
{
	return (pos < D2COMMON_nWeaponsTxt) ? pos :
	((pos -= D2COMMON_nWeaponsTxt) < D2COMMON_nArmorTxt) ? pos+ARRAYSIZE(anItemWeaponCols) :
	pos - D2COMMON_nArmorTxt + ARRAYSIZE(anItemWeaponCols) + ARRAYSIZE(anItemArmorCols);
}

ItemColours *GetItemColour2(int pos)
{
	return (pos < D2COMMON_nWeaponsTxt) ? &anItemWeaponCols[pos] :
		((pos -= D2COMMON_nWeaponsTxt) < D2COMMON_nArmorTxt) ? &anItemArmorCols[pos] :
		&anItemMiscCols[pos - D2COMMON_nArmorTxt];
}

char *GetItemColour(UnitAny *item)
{
	ItemTxt *itemtxt = D2COMMON_GetItemTxt(item->nTxtFileNo);

	if (itemtxt->dwCode == D2TXTCODE('gld ')) {
		return (D2COMMON_GetUnitStat(item, STAT_GOLD, 0) >= nGoldGoodNum) ? nGoldGoodCol : nGoldPoorCol;
	}

	if (itemtxt->nType == 74) {
		DWORD runeno = (itemtxt->szCode[1]-'0')*10+(itemtxt->szCode[2]-'0')-1;
		if (runeno < ARRAYSIZE(anRuneColours)) return anRuneColours[runeno];
	}

	int index = GetItemColourIndex(item->nTxtFileNo);
	if(index > ARRAYSIZE(anItemColours)-1 ) index = ARRAYSIZE(anItemColours)-1;
	int socknum = D2COMMON_GetUnitStat(item, STAT_NUMSOCKETS, 0);
	if( socknum > 6) socknum = 6;
	
	return anItemColours[index][(item->pItemData->nQuality-1)&7][!!D2COMMON_GetItemFlag(item, ITEMFLAG_ETHEREAL, 0, "?")][socknum];
}

//items name stuff
BYTE *szEtherealItemPrefix = NULL;
BYTE *szEtherealItemPostfix = NULL;
void __fastcall ItemNamePatch(wchar_t *name, UnitAny *item)
{
	wchar_t temp[0x40];
	int itemno = item->nTxtFileNo, quality = item->pItemData->nQuality, col = -1, bktnum = -1;

	ItemTxt *itemtxt = D2COMMON_GetItemTxt(itemno);

	trimspaces(name);

	col = GetItemColour(item)[0];

	if ((col == -1) && itemtxt->fQuest && (itemtxt->dwCode != D2TXTCODE('leg '))) col = nQuestItemColour;

	if (D2COMMON_GetItemFlag(item, STAT_UNK1, 0, "?")) col = nUnk1ItemColour;

	// gold
	if (itemtxt->dwCode == D2TXTCODE('gld ')) {
		// FIXME: name+0x40
		wcsrcat(name, wsprintfW2(temp, "%d ", D2COMMON_GetUnitStat(item, STAT_GOLD, 0)));
	}

	// ethereal
	if (D2COMMON_GetItemFlag(item, ITEMFLAG_ETHEREAL, 0, "?"))
	{
		if (szEtherealItemPrefix)
		{
			ConvertToD2String(temp, szEtherealItemPrefix, col, &temp[ARRAYSIZE(temp)-1]);
			wcsrcat(name, temp);
		}
		if (szEtherealItemPostfix)
			ConvertToD2String(name+wcslen(name), szEtherealItemPostfix, col, name+128);
	}
	
	// rune numbers
	if (tToggleRuneNumbers.flag && (itemtxt->nType == 74)) {
		bktnum = (itemtxt->szCode[1]-'0')*10+(itemtxt->szCode[2]-'0');
		wsprintfW2(name+wcslen(name), " (%d)", bktnum);
	}

	// socket number
	if (tToggleSocketNumbers.flag && D2COMMON_GetItemFlag(item, ITEMFLAG_SOCKETED, 0, "?")) {
		wsprintfW2(name+wcslen(name), " (%d)", D2COMMON_GetUnitStat(item, STAT_NUMSOCKETS, 0));
	}

	// item level
	if (tToggleItemLevel.flag && (itemtxt->dwCode != D2TXTCODE('gld '))) {
		wsprintfW2(name+wcslen(name), " (%ld)", item->pItemData->nItemLevel);
	}


	// item value
	if (tToggleItemValue.flag && (itemtxt->fQuest == 0) && (itemtxt->dwCode != D2TXTCODE('gld ')) ) {
		if (!D2CLIENT_GetUiVar(UIVAR_NPCTRADE)) {
			int value = D2COMMON_GetItemValue( D2CLIENT_GetPlayerUnit(), item, D2CLIENT_GetDifficulty(), D2CLIENT_GetQuestInfo(), nItemValueNpc, 1);
			wsprintfW2(name+wcslen(name), " ($%d)", value);
		}
	}

	// unit number
	if (tToggleUnitNumber.flag) {
		wsprintfW2(name+wcslen(name), " [0x%X]", item->nUnitId);
	}

	// item index
	if (tToggleItemIndex.flag) {
		wsprintfW2(name+wcslen(name), " [i%d]", GetItemColourIndex(item->nTxtFileNo)+1);
	}

	if (col != -1) ColourD2String(name, col);
}

void __declspec(naked) ItemNamePatch_ASM()
{
	__asm {
//ebx = ptr unit item
//edi = ptr item name string
		mov ecx, edi
		mov edx, ebx
		call ItemNamePatch
		mov al, [ebp+0x12a]
		ret
	}
}


//hide items stuff

BYTE __fastcall HideItemsPatch(UnitAny *unit)
{
	if (!tToggleHiddenItems.flag && (unit->nUnitType == UNITNO_ITEM)) {
		return (GetItemColour(unit)[1] == -2);
	}
	return 0;
}

void __declspec(naked) HideItemsPatch_ASM()
{
	__asm {
//esi = ptr unit
		mov [esi+0xec],eax //original code
		mov ecx,esi
		call HideItemsPatch
		test al,al
		je showitem
		add dword ptr [esp],-0x29
showitem:
		ret
	}
}

//monsters automap blob stuff

#define _0 -2
#define _1 -1

BYTE anMonsterColours[1000] = {
	_1, //0 Skeleton
	_1, //1 Returned
	_1, //2 BoneWarrior
	_1, //3 BurningDead
	_1, //4 Horror
	_1, //5 Zombie
	_1, //6 HungryDead
	_1, //7 Ghoul
	_1, //8 DrownedCarcass
	_1, //9 PlagueBearer
	_1, //10 Afflicted
	_1, //11 Tainted
	_1, //12 Misshapen
	_1, //13 Disfigured
	_1, //14 Damned
	_1, //15 FoulCrow
	_1, //16 BloodHawk
	_1, //17 BlackRaptor
	_1, //18 CloudStalker
	_1, //19 Fallen
	_1, //20 Carver
	_1, //21 Devilkin
	_1, //22 DarkOne
	_1, //23 WarpedFallen
	_1, //24 Brute
	_1, //25 Yeti
	_1, //26 Crusher
	_1, //27 WailingBeast
	_1, //28 GargantuanBeast
	_1, //29 SandRaider
	_1, //30 Marauder
	_1, //31 Invader
	_1, //32 Infidel
	_1, //33 Assailant
	_1, //34 unused, Gorgon
	_1, //35 unused, StoneStalker
	_1, //36 unused, SerpentQueen
	_1, //37 unused, StygianWatcher
	_1, //38 Ghost
	_1, //39 Wraith
	_1, //40 Specter
	_1, //41 Apparition
	_1, //42 DarkShape
	_1, //43 DarkHunter
	_1, //44 VileHunter
	_1, //45 DarkStalker
	_1, //46 BlackRogue
	_1, //47 FleshHunter
	_1, //48 DuneBeast
	_1, //49 RockDweller
	_1, //50 JungleHunter
	_1, //51 DoomApe
	_1, //52 TempleGuard
	_1, //53 MoonClan
	_1, //54 NightClan
	_1, //55 BloodClan
	_1, //56 HellClan
	_1, //57 DeathClan
	_1, //58 FallenShaman
	_1, //59 CarverShaman
	_1, //60 DevilkinShaman
	_1, //61 DarkShaman
	_1, //62 WarpedShaman
	_1, //63 QuillRat
	_1, //64 SpikeFiend
	_1, //65 ThornBeast
	_1, //66 RazorSpine
	_1, //67 JungleUrchin
	_1, //68 SandMaggot
	_1, //69 RockWorm
	_1, //70 Devourer
	_1, //71 GiantLamprey
	_1, //72 WorldKiller
	_1, //73 TombViper
	_1, //74 ClawViper
	_1, //75 Salamander
	_1, //76 PitViper
	_1, //77 SerpentMagus
	_1, //78 SandLeaper
	_1, //79 CaveLeaper
	_1, //80 TombCreeper
	_1, //81 TreeLurker
	_1, //82 RazorPitDemon
	_1, //83 Huntress
	_1, //84 SaberCat
	_1, //85 NightTiger
	_1, //86 HellCat
	_1, //87 Itchies
	_1, //88 BlackLocusts
	_1, //89 PlagueBugs
	_1, //90 HellSwarm
	_1, //91 DungSoldier
	_1, //92 SandWarrior
	_1, //93 Scarab
	_1, //94 SteelWeevil
	_1, //95 AlbinoRoach
	_1, //96 DriedCorpse
	_1, //97 Decayed
	_1, //98 Embalmed
	_1, //99 PreservedDead
	_1, //100 Cadaver
	_1, //101 HollowOne
	_1, //102 Guardian
	_1, //103 Unraveler
	_1, //104 Horadrim Ancient
	_1, //105 Baal Subject Mummy
	_1, //106 unused, DamnedHorde
	_1, //107 unused, TwistedHorde
	_1, //108 unused, WickedHorde
	_1, //109 unused, UnholyHorde
	_1, //110 CarrionBird
	_1, //111 UndeadScavenger
	_1, //112 HellBuzzard
	_1, //113 WingedNightmare
	_1, //114 Sucker
	_1, //115 Feeder
	_1, //116 BloodHook
	_1, //117 BloodWing
	_1, //118 Gloam
	_1, //119 SwampGhost
	_1, //120 BurningSoul
	_1, //121 BlackSoul
	_1, //122 Arach
	_1, //123 SandFisher
	_1, //124 PoisonSpinner
	_1, //125 FlameSpider
	_1, //126 SpiderMagus
	_1, //127 ThornedHulk
	_1, //128 BrambleHulk
	_1, //129 Thrasher
	_1, //130 Spikefist
	_1, //131 GhoulLord
	_1, //132 NightLord
	_1, //133 DarkLord
	_1, //134 BloodLord
	_1, //135 Banished
	_1, //136 DesertWing
	_1, //137 Fiend
	_1, //138 Gloombat
	_1, //139 BloodDiver
	_1, //140 DarkFamiliar
	_1, //141 RatMan
	_1, //142 Fetish
	_1, //143 Flayer
	_1, //144 SoulKiller
	_1, //145 StygianDoll
	_0, //146 DeckardCain
	_0, //147 Gheed
	_0, //148 Akara
	_0, //149 dummy, chicken
	_0, //150 Kashya
	_0, //151 dummy, rat
	_0, //152 Dummy, RogueTown
	_0, //153 Dummy, HellMeteor
	_0, //154 Charsi
	_0, //155 Warriv
	_1, //156 Andariel
	_0, //157 dummy, Smallbird
	_0, //158 dummy, Largebird
	_0, //159 dummy, Bat
	_1, //160 DarkRanger
	_1, //161 VileArcher
	_1, //162 DarkArcher
	_1, //163 BlackArcher
	_1, //164 FleshArcher
	_1, //165 DarkSpearwoman
	_1, //166 VileLancer
	_1, //167 DarkLancer
	_1, //168 BlackLancer
	_1, //169 FleshLancer
	_1, //170 SkeletonArcher
	_1, //171 ReturnedArcher
	_1, //172 BoneArcher
	_1, //173 BurningDeadArcher
	_1, //174 HorrorArcher
	_0, //175 Warriv
	_0, //176 Atma
	_0, //177 Drognan
	_0, //178 Fara
	_0, //179 dummy, Cow
	_1, //180 SandMaggotYoung
	_1, //181 RockWormYoung
	_1, //182 DevourerYoung
	_1, //183 GiantLampreyYoung
	_1, //184 WorldKillerYoung
	_0, //185 dummy, Camel
	_1, //186 Blunderbore
	_1, //187 Gorbelly
	_1, //188 Mauler
	_1, //189 Urdar
	_1, //190 SandMaggotEgg
	_1, //191 RockWormEgg
	_1, //192 DevourerEgg
	_1, //193 GiantLampreyEgg
	_1, //194 WorldKillerEgg
	_0, //195 dummy, Act2Male
	_0, //196 Dummy, Act2Female
	_0, //197 dummy, Act2Child
	_0, //198 Greiz
	_0, //199 Elzix
	_0, //200 Geglash
	_0, //201 Jerhyn
	_0, //202 Lysander
	_0, //203 Dummy, Act2Guard
	_0, //204 dummy, Act2Vendor1
	_0, //205 dummy, Act2Vendor2
	_1, //206 FoulCrowNest
	_1, //207 BloodHawkNest
	_1, //208 BlackVultureNest
	_1, //209 CloudStalkerNest
	_0, //210 Meshif
	_1, //211 Duriel
	_1, //212 Undead RatMan
	_1, //213 Undead Fetish
	_1, //214 Undead Flayer
	_1, //215 Undead SoulKiller
	_1, //216 Undead StygianDoll
	_1, //217 unused, DarkGuard
	_1, //218 unused, DarkKnight
	_1, //219 unused, BloodGuard
	_1, //220 unused, BloodKnight
	_1, //221 unused, DarkPaladin
	_1, //222 unused, BloodMage
	_1, //223 unused, Demonist
	_1, //224 unused, BlackMagus
	_1, //225 unused, Diabolist
	_1, //226 unused, DeathMage
	_0, //227 Maggot
	_1, //228 MummyGenerator
	_1, //229 Radament
	_1, //230 unused, FireBeast
	_1, //231 unused, IceGlobe
	_1, //232 unused, LightningBeast
	_1, //233 unused, PoisonOrb
	_1, //234 FlyingScimitar
	_1, //235 Zakarumite
	_1, //236 Faithful
	_1, //237 Zealot
	_1, //238 Sexton
	_1, //239 Cantor
	_1, //240 Heirophant
	_1, //241 Heirophant
	_1, //242 Mephisto
	_1, //243 Diablo
	_0, //244 DeckardCain
	_0, //245 DeckardCain
	_0, //246 DeckardCain
	_1, //247 Swamp Dweller
	_1, //248 Bog Creature
	_1, //249 Slime Prince
	_1, //250 Summoner
	_0, //251 tyrael
	_0, //252 asheara
	_0, //253 hratli
	_0, //254 alkor
	_0, //255 ormus
	_1, //256 izual
	_0, //257 halbu
	_1, //258 WaterWatcherLimb
	_1, //259 RiverStalkerLimb
	_1, //260 StygianWatcherLimb
	_1, //261 WaterWatcherHead
	_1, //262 RiverStalkerHead
	_1, //263 StygianWatcherHead
	_0, //264 meshif
	_0, //265 DeckardCain
	_0, //266 navi (flavie)
	_1, //267 Bloodraven
	_0, //268 Dummy, bug
	_0, //269 Dummy, scorpion
	_1, //270 RogueScout
	_1, //271 Dummy, RogueHireling (act1 hireling)
	_0, //272 Dummy, RogueTownShoot
	_1, //273 GargoyleTrap
	_1, //274 ReturnedMage
	_1, //275 BoneMage
	_1, //276 BurningDeadMage
	_1, //277 HorrorMage
	_1, //278 RatManShaman
	_1, //279 FetishShaman
	_1, //280 FlayerShaman
	_1, //281 SoulKillerShaman
	_1, //282 StygianDollShaman
	_0, //283 larva
	_1, //284 SandMaggotQueen
	_1, //285 RockWormQueen
	_1, //286 DevourerQueen
	_1, //287 GiantLampreyQueen
	_1, //288 WorldKillerQueen
	_1, //289 ClayGolem
	_1, //290 BloodGolem
	_1, //291 IronGolem
	_1, //292 FireGolem
	_0, //293 Dummy, Familiar
	_0, //294 Dummy, Act3Male
	_1, //295 NightMarauder
	_0, //296 Dummy, Act3Female
	_0, //297 Natalya
	_1, //298 FleshSpawner
	_1, //299 StygianHag
	_1, //300 Grotesque
	_1, //301 FleshBeast
	_1, //302 StygianDog
	_1, //303 GrotesqueWyrm
	_1, //304 Groper
	_1, //305 Strangler
	_1, //306 StormCaster
	_1, //307 Corpulent
	_1, //308 CorpseSpitter
	_1, //309 MawFiend
	_1, //310 DoomKnight
	_1, //311 AbyssKnight
	_1, //312 OblivionKnight
	_1, //313 QuillBear
	_1, //314 SpikeGiant
	_1, //315 ThornBrute
	_1, //316 RazorBeast
	_1, //317 GiantUrchin
	_0, //318 Dummy, Snake
	_0, //319 Dummy, Parrot
	_0, //320 Dummy, Fish
	_0, //321 Dummy, Evil Hole
	_0, //322 Dummy, Evil Hole
	_0, //323 Dummy, Evil Hole
	_0, //324 Dummy, Evil Hole
	_0, //325 Dummy, Evil Hole
	_0, //326 a trap, trapfirebolt
	_0, //327 a trap
	_0, //328 a trap (act2 wall, act3 totem)
	_0, //329 a trap, trappoison
	_0, //330 a trap, trapchainlightning
	_0, //331 Kaelan
	_0, //332 Dummy, InvisoSpawner
	_1, //333 unused, DiabloClone
	_1, //334 SuckerNest
	_1, //335 FeederNest
	_1, //336 BloodHookNest
	_1, //337 BloodWingNest
	_1, //338 Guard (act2 hireling)
	_0, //339 Dummy, MiniSpider
	_1, //340 x, PrisonFL
	_1, //341 x, PrisonFR
	_1, //342 x, PrisonBL
	_1, //343 x, PrisonBR
	_0, //344 Dummy, Bonewall*
	_1, //345 Council Member
	_1, //346 Council Member
	_1, //347 Council Member
	_1, //348 Turret1
	_1, //349 Turret2
	_1, //350 Turret3
	_0, //351 Hydra1
	_0, //352 Hydra2
	_0, //353 Hydra3
	_1, //354 a trap, pillar
	_0, //355 Dummy, seven tombs
	_1, //356 Dopplezon
	_1, //357 Valkyrie
	_0, //358 Dummy, Act2Hireling
	_0, //359 Iron Wolf (act3 town+hireling)*
	_1, //360 Balrog
	_1, //361 PitLord
	_1, //362 VenomLord
	_1, //363 NecroSkeleton (necro skel)
	_1, //364 NecroMage (necro mage)
	_1, //365 Griswold
	_0, //366 compellingorb
	_0, //367 tyrael
	_0, //368 youngdiablo
	_0, //369 a trap, nova
	_1, //370 Dummy, SpiritMummy
	_1, //371 LightningSpire
	_1, //372 FireTower
	_1, //373 Slinger
	_1, //374 SpearCat
	_1, //375 NightSlinger
	_1, //376 HellSlinger
	_0, //377 Dummy, Boba Fett
	_0, //378 Dummy, Darth Maul
	_1, //379 ReturnedMage
	_1, //380 BoneMage
	_1, //381 BaalColdMage
	_1, //382 HorrorMage
	_1, //383 ReturnedMage
	_1, //384 BoneMage
	_1, //385 BurningDeadMage
	_1, //386 HorrorMage
	_1, //387 ReturnedMage
	_1, //388 BoneMage
	_1, //389 BurningDeadMage
	_1, //390 HorrorMage
	_1, //391 Hell Bovine
	_0, //392 x, window right (act4 window)*
	_0, //393 x, window left (act4 window)*
	_1, //394 SpearCat
	_1, //395 NightSlinger
	_1, //396 RatMan
	_1, //397 Fetish
	_1, //398 Flayer
	_1, //399 SoulKiller
	_1, //400 StygianDoll
	_0, //401 Dummy, Mephisto Spirit
	_1, //402 The Smith
	_0, //403 TrappedSoul*
	_0, //404 TrappedSoul*
	_0, //405 Jamella
	_0, //406 Izual's Ghost
	_1, //407 RatMan
	_0, //408 Malachai?
	_1, //409 The Feature Creep

	_0, //410 Wake of Destruction
	_0, //411 Charged Bolt Sentry
	_0, //412 Lightning Sentry
	_0, //413 Blade Creeper (blade sentinel)
	_0, //414 Invis Pet*
	_0, //415 Inferno Sentry
	_0, //416 Death Sentry
	_1, //417 Shadow Warrior
	_1, //418 Shadow Master
	_1, //419 Druid Hawk*
	_1, //420 Druid Spirit Wolf
	_1, //421 Druid Fenris (dire wolf)
	_1, //422 Spirit of Barbs
	_1, //423 Heart of Wolverine
	_1, //424 Oak Sage
	_1, //425 Druid Plague Poppy (poison creeper)*
	_1, //426 Druid Cycle of Life (carrion vine)*
	_1, //427 Vine Creature (solar creeper)*
	_1, //428 Druid Bear
	_1, //429 Eagle
	_1, //430 Wolf
	_1, //431 Bear
	_0, //432 Barricade Door*
	_0, //433 Barricade Door*
	_0, //434 Prison Door*
	_0, //435 Barricade Tower*
	_1, //436 RotWalker
	_1, //437 ReanimatedHorde
	_1, //438 ProwlingDead
	_1, //439 UnholyCorpse
	_1, //440 DefiledWarrior
	_1, //441 Siege Beast
	_1, //442 CrushBiest
	_1, //443 BloodBringer
	_1, //444 GoreBearer
	_1, //445 DeamonSteed
	_1, //446 SnowYeti1
	_1, //447 SnowYeti2
	_1, //448 SnowYeti3
	_1, //449 SnowYeti4
	_1, //450 WolfRider1
	_1, //451 WolfRider2
	_1, //452 WolfRider3
	_1, //453 Minionexp
	_1, //454 Slayerexp
	_1, //455 IceBoar
	_1, //456 FireBoar
	_1, //457 HellSpawn
	_1, //458 IceSpawn
	_1, //459 GreaterHellSpawn
	_1, //460 GreaterIceSpawn
	_1, //461 FanaticMinion
	_1, //462 BerserkSlayer
	_1, //463 ConsumedFireBoar
	_1, //464 ConsumedIceBoar
	_1, //465 FrenziedHellSpawn
	_1, //466 FrenziedIceSpawn
	_1, //467 InsaneHellSpawn
	_1, //468 InsaneIceSpawn
	_1, //469 Succubusexp
	_1, //470 VileTemptress
	_1, //471 StygianHarlot
	_1, //472 Hell Temptress
	_1, //473 Blood Temptress
	_1, //474 Dominus
	_1, //475 VileWitch
	_1, //476 StygianFury
	_1, //477 Blood Witch
	_1, //478 Hell Witch
	_1, //479 OverSeer
	_1, //480 Lasher
	_1, //481 OverLord
	_1, //482 BloodBoss
	_1, //483 HellWhip
	_1, //484 MinionSpawner
	_1, //485 MinionSlayerSpawner
	_1, //486 MinionIce/fireBoarSpawner
	_1, //487 MinionIce/fireBoarSpawner
	_1, //488 Minionice/hellSpawnSpawner
	_1, //489 MinionIce/fireBoarSpawner
	_1, //490 MinionIce/fireBoarSpawner
	_1, //491 Minionice/hellSpawnSpawner
	_1, //492 Imp1
	_1, //493 Imp2
	_1, //494 Imp3
	_1, //495 Imp4
	_1, //496 Imp5
	_1, //497 CatapultS
	_1, //498 CatapultE
	_1, //499 CatapultSiege
	_1, //500 CatapultW
	_1, //501 Frozen Horror1
	_1, //502 Frozen Horror2
	_1, //503 Frozen Horror3
	_1, //504 Frozen Horror4
	_1, //505 Frozen Horror5
	_1, //506 Blood Lord1
	_1, //507 Blood Lord2
	_1, //508 Blood Lord3
	_1, //509 Blood Lord4
	_1, //510 Blood Lord5
	_0, //511 Larzuk
	_0, //512 Drehya
	_0, //513 Malah
	_0, //514 Nihlathak Town
	_0, //515 Qual-Kehk
	_0, //516 Catapult Spotter S (target?)
	_0, //517 Catapult Spotter E (target?)
	_0, //518 Catapult Spotter Siege (target?)
	_0, //519 Catapult Spotter W
	_0, //520 DeckardCain
	_0, //521 tyrael
	0xcb, //522 Act 5 Combatant (barb fighter)*
	_0, //523 Act 5 Combatant*
	_0, //524 Barricade Wall Right*
	_0, //525 Barricade Wall Left*
	_1, //526 Nihlathak outside town
	_0, //527 Drehya outside town
	_1, //528 Evil hut
	_1, //529 Death Mauler1
	_1, //530 Death Mauler2
	_1, //531 Death Mauler3
	_1, //532 Death Mauler4
	_1, //533 Death Mauler5
	_0, //534 POW (captured barb)*
	_0, //535 Act 5 Townguard
	_0, //536 Act 5 Townguard
	_0, //537 Ancient Statue 1
	_0, //538 Ancient Statue 2
	_0, //539 Ancient Statue 3
	_1, //540 Ancient Barbarian 1
	_1, //541 Ancient Barbarian 2
	_1, //542 Ancient Barbarian 3
	_0, //543 Baal Throne
	_1, //544 Baal Crab
	_0, //545 Baal Taunt (invis follower)
	_1, //546 Putrid Defiler1
	_1, //547 Putrid Defiler2
	_1, //548 Putrid Defiler3
	_1, //549 Putrid Defiler4
	_1, //550 Putrid Defiler5
	_1, //551 Pain Worm1
	_1, //552 Pain Worm2
	_1, //553 Pain Worm3
	_1, //554 Pain Worm4
	_1, //555 Pain Worm5
	_0, //556 Bunny
	_1, //557 Council Member
	_1, //558 VenomLord
	_0, //559 Baal Crab to Stairs
	_1, //560 Act 5 Hireling 1hs
	_1, //561 Act 5 Hireling 2hs (act5 hireling)
	_1, //562 Baal Tentacle
	_1, //563 Baal Tentacle
	_1, //564 Baal Tentacle
	_1, //565 Baal Tentacle
	_1, //566 Baal Tentacle
	_0, //567 Injured Barbarian 1 (town barb)
	_0, //568 Injured Barbarian 2 (town barb)
	_0, //569 Injured Barbarian 3 (town barb)
	_1, //570 Baal Crab Clone
	_1, //571 Baals Minion
	_1, //572 Baals Minion
	_1, //573 Baals Minion
	_0, //574 Worldstone Effect
	_1, //575
	_1, //576
	_1, //577
	_1, //578
	_1, //579
	_1, //580
	_1, //581
	_1, //582
	_1, //583
	_1, //584
	_1, //585
	_1, //586
	_1, //587
	_1, //588
	_1, //589
	_1, //590
	_1, //591
	_1, //592
	_1, //593
	_1, //594
	_1, //595
	_1, //596
	_1, //597
	_1, //598
	_1, //599
	_1, //600
	_1, //601
	_1, //602
	_1, //603
	_1, //604
	_1, //605
	_1, //606
	_1, //607
	_1, //608
	_1, //609
	_1, //610
	_1, //611
	_1, //612
	_1, //613
	_1, //614
	_1, //615
	_1, //616
	_1, //617
	_1, //618
	_1, //619
	_1, //620
	_1, //621
	_1, //622
	_1, //623
	_1, //624
	_1, //625
	_1, //626
	_1, //627
	_1, //628
	_1, //629
	_1, //630
	_1, //631
	_1, //632
	_1, //633
	_1, //634
	_1, //635
	_1, //636
	_1, //637
	_1, //638
	_1, //639
	_1, //640
	_1, //641
	_1, //642
	_1, //643
	_1, //644
	_1, //645
	_1, //646
	_1, //647
	_1, //648
	_1, //649
	_1, //650
	_1, //651
	_1, //652
	_1, //653
	_1, //654
	_1, //655
	_1, //656
	_1, //657
	_1, //658
	_1, //659
	_1, //660
	_1, //661
	_1, //662
	_1, //663
	_1, //664
	_1, //665
	_1, //666
	_1, //667
	_1, //668
	_1, //669
	_1, //670
	_1, //671
	_1, //672
	_1, //673
	_1, //674
	_1, //675
	_1, //676
	_1, //677
	_1, //678
	_1, //679
	_1, //680
	_1, //681
	_1, //682
	_1, //683
	_1, //684
	_1, //685
	_1, //686
	_1, //687
	_1, //688
	_1, //689
	_1, //690
	_1, //691
	_1, //692
	_1, //693
	_1, //694
	_1, //695
	_1, //696
	_1, //697
	_1, //698
	_1, //699
	_1, //700
	_1, //701
	_1, //702
	_1, //703
};

#undef _0
#undef _1

int nCurrentAct;
BYTE anLockedChestColors[] = {9,9,9,9,9};
BYTE anClosedChestColors[] = {9,9,9,9,9};
BYTE anHostileMissileColors[] = {0x62,0x62,0x62,0x62,0x62};
BYTE anGuidedMissileColors[] = {0x5B,0x5B,0x5B,0x5B,0x5B};
BYTE anTracerMissileColors[] = {0xFF,0xFF,0xFF,0xFF,0xFF};
BYTE anOtherMissileColors[] = {0xFF,0xFF,0xFF,0xFF,0xFF};


BYTE anMissileColours[1000];

//mixed automap blob stuff

int IsObjectChest(int objno)
{
	ObjectTxt *obj = D2COMMON_GetObjectTxt(objno);
	return (obj->nSelectable0 && (
		(obj->nOperateFn == 1) || //bed, undef grave, casket, sarc
		(obj->nOperateFn == 3) || //basket, urn, rockpile, trapped soul
		(obj->nOperateFn == 4) || //chest, corpse, wooden chest, buriel chest, skull and rocks, dead barb
		(obj->nOperateFn == 5) || //barrel
		(obj->nOperateFn == 7) || //exploding barrel
		(obj->nOperateFn == 14) || //loose bolder etc....*
		(obj->nOperateFn == 19) || //armor stand
		(obj->nOperateFn == 20) || //weapon rack
		(obj->nOperateFn == 33) || //writ
		(obj->nOperateFn == 48) || //trapped soul
		(obj->nOperateFn == 51) || //stash
		(obj->nOperateFn == 68)    //evil urn
		));
}

BYTE __fastcall MixedBlobColPatch(UnitAny *unit)
//note will use bad text colour for stash if dont return -1
{
	if (unit->nUnitType == UNITNO_OBJECT) {
		if (tToggleAutomapChests.flag && IsObjectChest(unit->nTxtFileNo) && !unit->eMode) {
			return (unit->pObjectData->fChestLocked) ? anLockedChestColors[nCurrentAct] : anClosedChestColors[nCurrentAct];
		}
	} else if (unit->nUnitType == UNITNO_MISSILE) {
		if (tToggleAutomapMissiles.flag && !(unit->fFlags0&1)) { // FIXME fFlag0--> test fFlag0, 1
			if (anMissileColours[unit->nTxtFileNo] != (BYTE)-2) return anMissileColours[unit->nTxtFileNo];
			if (unit->nOwnerType == UNITNO_PLAYER) {
				if (unit->nOwnerId == D2CLIENT_GetPlayerUnit()->nUnitId) {
					return anTracerMissileColors[nCurrentAct];
				}
				if (D2CLIENT_TestPvpFlag(unit->nOwnerId, D2CLIENT_GetPlayerUnit()->nUnitId, 8)) {
					return (unit->pPos->pTargetUnit == D2CLIENT_GetPlayerUnit()) ? anGuidedMissileColors[nCurrentAct] : anHostileMissileColors[nCurrentAct];
				} 
			}
			return anOtherMissileColors[nCurrentAct];
		}
	} else if (unit->nUnitType == UNITNO_ITEM) {
		if (tToggleAutomapItems.flag) return GetItemColour(unit)[1];
	}
	return -1;
}



BYTE anMonsterNormalColors[] = {0x62,0x62,0x62,0x62,0x62};
BYTE anMonsterBossColors[] = {0x5b,0x5b,0x5b,0x5b,0x5b};
BYTE anMonsterMinionColors[] = {0x5b,0x5b,0x5b,0x5b,0x5b};
BYTE anMonsterChampColors[] = {0x5b,0x5b,0x5b,0x5b,0x5b};
BYTE anNeutralPlayerColors[] = {0x62,0x62,0x62,0x62,0x62};
BYTE anHostilePlayerColors[] = {0x5b,0x5b,0x5b,0x5b,0x5b};
BYTE anNormalCorpseColors[] = {8,8,8,8,8};
BYTE anBossCorpseColors[] = {8,8,8,8,8};
BYTE anMinionCorpseColors[] = {8,8,8,8,8};
BYTE anChampionCorpseColors[] = {8,8,8,8,8};

BYTE anMonsterCorpseColors[1000];
struct DangerousMonster {
	BYTE type;
	char stat;
}anDangerousMonster[1000];
BYTE fGameShutdow;

void ChickenQuit(wchar_t* quitinfo, int no = 8)
{
	if (fGameShutdow == 0) {
		D2CLIENT_PrintGameStringAtTopLeft(quitinfo, no);
		D2ExitGame(0);
		fGameShutdow = 1;
	}
}

BYTE __fastcall MonsterBlobColPatch2(UnitAny *mon)
{
	if (tToggleAutomapMonsters.flag) {
		if (anMonsterColours[mon->nTxtFileNo] != (BYTE)-1) return anMonsterColours[mon->nTxtFileNo];
		if (mon->pMonsterData->fChamp & 1) return anMonsterChampColors[nCurrentAct];
		if (mon->pMonsterData->fMinion & 1) return anMonsterMinionColors[nCurrentAct];
		if (mon->pMonsterData->fBoss & 1) return anMonsterBossColors[nCurrentAct];
		return anMonsterNormalColors[nCurrentAct];
	}
	return -2;
}

BYTE __fastcall MonsterBlobColPatch(UnitAny *mon)
{
	if (mon->nUnitType == UNITNO_MONSTER) {
		if (mon->eMode && mon->eMode != 0x0C) {
			return MonsterBlobColPatch2(mon);
		}
		if (tToggleAutomapCorpse.flag) {
			int index = D2COMMON_GetMonsterColorIndex(mon, 0);
			if (index) {
				if (anMonsterCorpseColors[index] == (BYTE)-1) {
					if (mon->pMonsterData->fChamp & 1) return anChampionCorpseColors[nCurrentAct];
					if (mon->pMonsterData->fMinion & 1) return anMinionCorpseColors[nCurrentAct];
					if (mon->pMonsterData->fBoss & 1) return anBossCorpseColors[nCurrentAct];
					return anMonsterNormalColors[nCurrentAct];
				}
				return anMonsterCorpseColors[index];
			}
		}
	}
	return MixedBlobColPatch(mon);
}

void __declspec(naked) MonsterBlobColPatch_ASM()
{
	__asm {
//esi = ptr unit monster
//ebx = ptr colour
//return eax = draw flag
		mov ecx,esi
		call MonsterBlobColPatch
		mov [ebx],al
		sub al,-4
		setb al
		movzx eax,al
		pop esi
		add esp, 0x0C
		ret
	}
}

void __declspec(naked) MonsterDieingPatch_ASM()
{
	__asm {
//esi = ptr unit monster
//return eax = skip flag
		cmp [esi]UnitAny.eMode,0 //monster mode = Death/DT
		je monsterdead
		test eax,0x200000 //original code
		ret
monsterdead:
		or al,1
		ret
	}
}

//players automap blob stuff


BYTE __fastcall PlayerBlobColPatch(UnitAny *pla)
{
	return D2CLIENT_TestPvpFlag(pla->nUnitId, D2CLIENT_GetPlayerUnit()->nUnitId, 8) ? anHostilePlayerColors[nCurrentAct] : anNeutralPlayerColors[nCurrentAct];
}

void __declspec(naked) PlayerBlobColPatch_ASM()
{
	__asm {
//esi = ptr unit player
//return cl = colour
		mov ecx,esi
		call PlayerBlobColPatch
		mov cl,al
		ret
	}
}

//monsters automap name stuff

BYTE *aszEnchantDescs[50];
BYTE *aszAuraDescs[7];
BYTE *aszImmuneDescs[6];

BYTE nMonsterTextCol = 1;

BOOL __fastcall MonsterBlobNamePatch(UnitAny *mon, int xpos, int ypos)
{
	wchar_t temp[1024], *p = temp;
	BYTE txtcol = (nMonsterTextCol > 12) ? 0 : nMonsterTextCol;
	if (mon->eMode && mon->eMode != 0x0C && D2CLIENT_GetMonsterOwner(mon->nUnitId) == -1) {
		if (mon->pMonsterData->fBoss & 1) {
			int aura = 0, enchno;
			for (int i = 0; i < 9; i++) {
				enchno = mon->pMonsterData->anEnchants[i];
				if (enchno == 0) break;
				if (enchno == 30) aura = 1;
				if (enchno < 32 && aszEnchantDescs[enchno]) {
					p = ConvertToD2String(p, aszEnchantDescs[enchno], txtcol, &temp[ARRAYSIZE(temp)-1]);
				}
			}

			if (aura) {
				//NOTE :- testing if monster effected by aura, NOT source of aura
				static BYTE states[7] = {0x21, 0x23, 0x28, 0x2b, 0x2e, 0x1c, 0x31};
				for (int i = 0; i < ARRAYSIZE(states); i++) {
					if (aszAuraDescs[i] && D2COMMON_GetUnitState(mon, states[i])) {
						p = ConvertToD2String(p, aszAuraDescs[i], txtcol, &temp[ARRAYSIZE(temp)-1]);
					}
				}
			}
		}

		static BYTE stats[6] = {0x24, 0x25, 0x27, 0x29, 0x2b, 0x2d};
		for (int i = 0; i < ARRAYSIZE(stats); i++) {
			if (aszImmuneDescs[i] && D2COMMON_GetUnitStat(mon, stats[i], 0) >= 100) {
				//FIXME
				p = ConvertToD2String(p, aszImmuneDescs[i], txtcol, &temp[ARRAYSIZE(temp)-1]);
			}
		}
	}
	
	if (p > temp)
		D2DrawCenterText(6, temp, xpos, ypos-10, txtcol);
	return FALSE;
}

void __declspec(naked) MonsterBlobNamePatch_ASM()
{
	__asm {
//esi = ptr unit monster
//edi = x pos
//ebx = y pos
		mov ecx,esi
		mov edx,edi
		push ebx
		call MonsterBlobNamePatch
		test eax,eax
		mov eax, [esi+4]
		jz oldcode
		jmp D2CLIENT_GetMonsterTxt_I // draw monster name
oldcode:
//original code
		mov edx, 9
		jmp D2CLIENT_GetMonsterTxt_I2
	}
}



void __declspec(naked) MixedBlobColPatch_ASM()
{
	__asm {
//esi = ptr unit
		mov ecx,esi
		call MixedBlobColPatch
		cmp al,-1
		jne gotcol
		cmp [esi]UnitAny.nUnitType, UNITNO_OBJECT
		je defcol
		dec al //now -2
gotcol:
		pop ecx //return
//originalish code
		mov [ebx],al
		sub al,-2
		movzx eax,al
		pop edi
		pop esi
		pop ebx
defcol:
		ret
	}
}

//blob draw stuff

char *apUnitBlobFiles[6];

CellFile *apUnitBlobCells[6];
void InitBlobs()
{
	for (int i = 0; i < ARRAYSIZE(apUnitBlobCells); i++) {
		char filename[MAX_PATH];
		if (apUnitBlobFiles[i]) wsprintf(GetMyFileNameStrrchr(filename, '\\'), "%s.BMP", apUnitBlobFiles[i]);
		apUnitBlobCells[i] = apUnitBlobFiles[i] ? InitCellFile(LoadBmpCellFile(filename)) : 0;
	}
}

void DeleteBlobs()
{
	for (int i = 0; i < ARRAYSIZE(apUnitBlobCells); i++) {
		DeleteCellFile(apUnitBlobCells[i]);
	}
}

void DrawAutomapCell2(CellFile *cellfile, int xpos, int ypos, BYTE col)
{
	CellContext ct;
	memset(&ct, 0, sizeof(ct));
	if (!(ct.pCellFile = cellfile)) return;

	xpos -= (cellfile->cells[0]->width/2);
	ypos += (cellfile->cells[0]->height/2);

	int xpos2 = xpos - cellfile->cells[0]->xoffs, ypos2 = ypos - cellfile->cells[0]->yoffs;
	if ((xpos2 >= D2GetScreenSizeX()) || ((xpos2 + (int)cellfile->cells[0]->width) <= 0) || (ypos2 >= D2GetScreenSizeY()) || ((ypos2 + (int)cellfile->cells[0]->height) <= 0)) return;

	static BYTE coltab[2][256];//, tabno = 0, lastcol = 0;
	if (!coltab[0][1]) for (int k = 0; k < 255; k++) coltab[0][k] = coltab[1][k] = k;
	cellfile->mylastcol = coltab[cellfile->mytabno ^= (col != cellfile->mylastcol)][255] = col;

	D2GFX_DrawAutomapCell2(&ct, xpos, ypos, -1, 5, coltab[cellfile->mytabno]);
}

void __fastcall DrawAutomapBlob(int xpos, int ypos, DWORD col, DWORD unittype)
{
	if (D2CLIENT_GetAutomapSize()) {
		xpos -= 1;
		ypos += 5;
	}
	if (!apUnitBlobCells[unittype]) {
		static char blines[][2] = {0,-2, 4,-4, 8,-2, 4,0, 8,2, 4,4, 0,2, -4,4, -8,2, -4,0, -8,-2, -4,-4, 0,-2};
		for (int i = 0; i < ARRAYSIZE(blines)-1; i++) {
			D2GFX_DrawLine(xpos+blines[i][0], ypos+blines[i][1], xpos+blines[i+1][0], ypos+blines[i+1][1], col, 0xff);
		}
	} else {
		DrawAutomapCell2(apUnitBlobCells[unittype], xpos, ypos, (BYTE)col);
	}
}

void __declspec(naked) DrawAutomapBlob_ASM()
{
	__asm {
		push [esp+8]
		mov edx, eax
		call DrawAutomapBlob
		ret 4
	}
}

void __fastcall DrawObjectBlobPatch(int xpos, int ypos, DWORD col)
{
	DrawAutomapBlob(xpos, ypos, col, UNITNO_OBJECT);
}

void __declspec(naked) DrawObjectBlobPatch_ASM()
{
	__asm {
		push UNITNO_OBJECT
		jmp DrawAutomapBlob_ASM
	}
}

void __fastcall DrawPlayerBlobPatch(int xpos, int ypos, DWORD col)
{
	DrawAutomapBlob(xpos, ypos, col, UNITNO_PLAYER);
}

void __declspec(naked) DrawPlayerBlobPatch_ASM()
{
	__asm {
		push UNITNO_PLAYER
		jmp DrawAutomapBlob_ASM
	}
}

void __declspec(naked) DrawMonsterBlobPatch_ASM()
{
	__asm {
		push UNITNO_MONSTER
		jmp DrawAutomapBlob_ASM
	}
}

void __declspec(naked) DrawItemBlobPatch_ASM()
{
	__asm {
//eax = unit type-2
//edi = x pos
//ebx = y pos
//[esp+0x10] = col
		test eax,eax
		jne notunit2
//original code
		ret
notunit2:
		add eax,2
		push eax
		push dword ptr [esp+0x18]
		mov ecx,edi
		mov edx,ebx
		call DrawAutomapBlob
		add dword ptr [esp], 0x59
		ret
	}
}

void __declspec(naked) DrawPlayerBlobPatch2_ASM()
{
	__asm {
//dl = col
//ecx = x pos
//eax = y pos
		push UNITNO_PLAYER
		push edx
		mov edx,eax
		call DrawAutomapBlob
//		add dword ptr [esp], 0x36
		ret
	}
}

BYTE __fastcall HostilePlayerPatch(UnitAny *unit)
{
	return D2CLIENT_TestPvpFlag(unit->nUnitId, D2CLIENT_GetPlayerUnit()->nUnitId, 8)
		? anHostilePlayerColors[nCurrentAct]
		: anNeutralPlayerColors[nCurrentAct];
}

void __declspec(naked) HostilePlayerColor_ASM()
{
	__asm {
		mov ecx, esi
		call HostilePlayerPatch
		mov cl, al
		ret
	}
}

//monster stuff

BYTE afMonsterCorpses[1000];
BYTE afMissileCorpses[1000];
BYTE afMonsterDeathAnims[1000];

BYTE nHiddenItemLevel;

wchar_t * __fastcall OpenCubeStringPatch(wchar_t *str, DWORD col)
{
	return ColourD2String(str, (nQuestItemColour != -1) ? nQuestItemColour : col);
}

void __declspec(naked) OpenCubeStringPatch_ASM()
{
	__asm {
	//edi = str
	//esi = col
	mov ecx, edi
	mov edx, esi
	call OpenCubeStringPatch
	ret 4
	}
}


BOOL __fastcall InfravisionPatch3(UnitAny *unit)
{
	switch(unit->nUnitType) {
	case UNITNO_PLAYER:
		if (!unit->eMode || unit->eMode == 0x11) return FALSE;
		break;
	case UNITNO_MONSTER:
		if (!unit->eMode || unit->eMode == 0x0C) return FALSE;
		break;
	case UNITNO_ITEM:
		break;
	default:
		return FALSE;
	}
	DrlgLevel *curlvl = GetUnitDrlgLevel(unit);
	if (curlvl && !D2COMMON_GetFunUnk_5(curlvl->nLevelNo)) return FALSE;
	return D2COMMON_TestFunUnk_6(D2CLIENT_GetPlayerUnit(), unit, 2);
}

BOOL __fastcall InfravisionPatch2(UnitAny *unit)
{
	BYTE c;
	switch(unit->nUnitType) {
	case UNITNO_MONSTER:
		if (!tToggleHiddenCorpse.flag && unit->eMode == 0x0C) {
			return afMonsterCorpses[unit->nTxtFileNo] == 0;
		}
		break;
	case UNITNO_MISSILE:
		if (!tToggleHiddenCorpse.flag && (unit->fFlags0)) {
			return afMissileCorpses[unit->nTxtFileNo] == 0;
		}
		break;
	case UNITNO_ITEM:
		c = (BYTE)GetItemColour(unit)[1];
		if (c == 0xFC) return TRUE;
		if (!tToggleHiddenItems.flag) {
			if (c == 0xFD)
				return unit->pItemData->nItemLevel == nHiddenItemLevel;
			else
				return c == 0xFE;
		}
		break;
	}
	return FALSE;
}

BYTE abGetPlayerStat[0x8363C-0x830C0+100];
DWORD anGetPlayerStatJmpTbl[11];
DWORD anGetPlayerStatJmpTbl2[9];
BOOL PrepareGetPlayerStat()
{
	LPBYTE ps = (LPBYTE)D2CLIENT_GetPlayerStat;
	LPBYTE pe = (LPBYTE)D2CLIENT_GetPlayerStat_END;

	BYTE prelog[] = {0x81, 0xEC, 0x70, 0x03, 0x00, 0x00,		// sub esp, 0x3B0
					 0x89, 0x4c, 0x24, 0x1C,					// mov dword ptr [esp+0x1C], ecx
					 0x89, 0x54, 0x24, 0x18,};					// mov dword ptr [esp+0x18], edx
	BYTE epilog[] = {0x8b, 0xc6,								// mov eax, esi
					 0x81, 0xc4, 0x7c, 0x03,					// add esp, 0x37C
					 0x00, 0x00, 0xc3};							// ret
	memcpy(anGetPlayerStatJmpTbl, *(DWORD**)D2CLIENT_GetPlayerStatJmpTbl, sizeof(anGetPlayerStatJmpTbl));
	int offsetjmptbl = (PBYTE)D2CLIENT_GetPlayerStatJmpTbl-ps;
	memcpy(anGetPlayerStatJmpTbl2, *(DWORD**)D2CLIENT_GetPlayerStatJmpTbl2, sizeof(anGetPlayerStatJmpTbl2));
	int offsetjmptbl2 = (PBYTE)D2CLIENT_GetPlayerStatJmpTbl2-ps;

	memcpy(abGetPlayerStat, prelog, sizeof(prelog));
	memcpy(abGetPlayerStat+sizeof(prelog)+(pe-ps), epilog, sizeof(epilog));
	memcpy(abGetPlayerStat+sizeof(prelog), ps, pe-ps);

	int offsetofcall = ps-(LPBYTE)abGetPlayerStat-sizeof(prelog);
	for (int i = 0; i < pe-ps; i++) {
		if (abGetPlayerStat[i] == INST_CALL && abGetPlayerStat[i+1] != INST_CALL) {
			// adjust call offset
			*(int*)(abGetPlayerStat+i+1) += offsetofcall;
		}
	}
	for (i = 0; i < ARRAYSIZE(anGetPlayerStatJmpTbl); i++) {
		anGetPlayerStatJmpTbl[i] += abGetPlayerStat+sizeof(prelog) - ps;
	}
	*(DWORD*)(abGetPlayerStat+sizeof(prelog)+offsetjmptbl) = (DWORD)anGetPlayerStatJmpTbl;
	for (i = 0; i < ARRAYSIZE(anGetPlayerStatJmpTbl2); i++) {
		anGetPlayerStatJmpTbl2[i] += abGetPlayerStat+sizeof(prelog) - ps;
	}
	*(DWORD*)(abGetPlayerStat+sizeof(prelog)+offsetjmptbl2) = (DWORD)anGetPlayerStatJmpTbl2;

	return TRUE;
}

 int __declspec(naked) __fastcall GetPlayerStat2(UnitAny *pla, int statindex)
 {
	 __asm
	 {
		 pushad;
		 lea eax, abGetPlayerStat;
		 call eax;
		 mov [esp]I386Registers.eax, eax;
		 popad;
		 ret;
	 }
 }

inline
BOOL TestMonsterOnScreen(UnitAny *mon, UnitAny *pla)
{
	return abs((int)mon->pPos->xpos2-(int)pla->pPos->xpos2) < D2GetScreenSizeX()/2
		&& abs((int)mon->pPos->ypos2-(int)pla->pPos->ypos2) < (D2GetScreenSizeY()-48)/2;
}

void BackToTown();
BYTE fBackToTown;
BYTE fDangerousMonsterAction;
BYTE fDangerousMonsterActive;
BYTE fGetPlayerStatPrepared;
void CheckPlayerStat(UnitAny *mon)
{
	if (!fGetPlayerStatPrepared) {
		fGetPlayerStatPrepared = PrepareGetPlayerStat();
	}
	UnitAny *pla = D2CLIENT_GetPlayerUnit();
	static BYTE statindexs[] = {0x0e, 0x0f, 0x10, 0x11};
//	static BYTE statindexs[] = {0x0e, 0x10, 0x0f, 0x11};
	if (anDangerousMonster[mon->nTxtFileNo].type && anDangerousMonster[mon->nTxtFileNo].type < ARRAYSIZE(statindexs)+1 && TestMonsterOnScreen(mon, pla)) {
		int stat = GetPlayerStat2(pla, statindexs[anDangerousMonster[mon->nTxtFileNo].type-1]);
		if (anDangerousMonster[mon->nTxtFileNo].stat <= stat) {
			if (fDangerousMonsterActive == 0) {
				fDangerousMonsterActive = 1;
				if (fDangerousMonsterAction == 2) {
					D2CLIENT_PrintGameStringAtTopLeft(L"<Hackmap>: player's resistance below chicken threshold, returning town.", 8);
					BackToTown();
				} else if (fDangerousMonsterAction == 1) {
					ChickenQuit(L"<Hackmap>: player's resistance below chicken threshold, exiting game.");
				}
			}
		}
	}
}

BOOL TestPlayerInTown(UnitAny *unit)
{
	DrlgLevel* curlvl = GetUnitDrlgLevel(unit);
	return curlvl ?
		curlvl->nLevelNo == 1	// act1
		|| curlvl->nLevelNo == 40	// act2
		|| curlvl->nLevelNo == 75	// act3
		|| curlvl->nLevelNo == 103	// act4
		|| curlvl->nLevelNo == 109	// act5
		: FALSE;
}

BOOL __fastcall InfravisionPatch(UnitAny *unit)
{
	if (tToggleChickenDangerousMonster.flag && unit->nUnitType == UNITNO_MONSTER && unit->eMode && unit->eMode != 0x0C) {
		if (!TestPlayerInTown(D2CLIENT_GetPlayerUnit())) {
			CheckPlayerStat(unit);
		} else if (fDangerousMonsterActive) {
			fDangerousMonsterActive = 0;
		}
	}
	if (InfravisionPatch2(unit)) return TRUE;
	return !tToggleInfravision.flag ? InfravisionPatch3(unit) : FALSE;
}

void __declspec(naked) InfravisionPatch_ASM()
{
	__asm {
		mov ecx, esi
		call InfravisionPatch
		add dword ptr [esp], 0x72
		ret
	}
}

BYTE anAutomapActiveRoomColors[] = {0x16, 0x16, 0x16, 0x16, 0x16};
BYTE anAutomapReadyColors[] = {7 ,7, 7, 7, 7};
BYTE anAutomapScreenColors[] = {0x16, 0x16, 0x16, 0x16, 0x16};

void ScreenToAutomap(POINT* pos, int x, int y)
{
	pos->x = (x-y)/2/D2CLIENT_nPtDivisor-D2CLIENT_ptOffset.x+8;
	pos->y = (x+y)/4/D2CLIENT_nPtDivisor-D2CLIENT_ptOffset.y-8;
	if (D2CLIENT_GetAutomapSize()) {
		--pos->x;
		pos->y += 5;
	}
}

void ScreenToAutomapRelative(POINT* pos, int x, int y)
{
	x += D2CLIENT_GetPlayerXOffest();
	y += D2CLIENT_GetPlayerYOffset();
	ScreenToAutomap(pos, y*2+x, y*2-x);
}

inline void D2GetPlayerPosition(POINT* ptPlayer)
{
	ScreenToAutomapRelative(ptPlayer, D2GetScreenSizeX()/2, (D2GetScreenSizeY()-48)/2);
}

void RoomPatch2(DrlgRoom2 *pRoom2, DWORD col)
{
	POINT ptTopLeft, ptTopRight, ptBottomLeft, ptBottomRight;
	ScreenToAutomap(&ptTopLeft, pRoom2->xPos*160, pRoom2->yPos*160);
	ScreenToAutomap(&ptTopRight, (pRoom2->xPos+pRoom2->xPos1)*160, pRoom2->yPos*160);
	ScreenToAutomap(&ptBottomLeft, pRoom2->xPos*160, (pRoom2->yPos+pRoom2->yPos1)*160);
	ScreenToAutomap(&ptBottomRight, (pRoom2->xPos+pRoom2->xPos1)*160, (pRoom2->yPos+pRoom2->yPos1)*160);

	D2GFX_DrawLine(ptTopLeft.x, ptTopLeft.y, ptTopRight.x, ptTopRight.y, col, -1);
	D2GFX_DrawLine(ptBottomLeft.x, ptBottomLeft.y, ptBottomRight.x, ptBottomRight.y, col, -1);
	D2GFX_DrawLine(ptTopLeft.x, ptTopLeft.y, ptBottomLeft.x, ptBottomLeft.y, col, -1);
	D2GFX_DrawLine(ptTopRight.x, ptTopRight.y, ptBottomRight.x, ptBottomRight.y, col, -1);
}

void DrawMinimapLevel(int lvlno);
void RoomPatch()
{
	if (tToggleAutomapReadyRoom.flag) {
		DrlgRoom1 *pRoom1 = D2CLIENT_pDrlgAct->pRoom1;
		while (pRoom1) {
			RoomPatch2(pRoom1->pRoom2, anAutomapReadyColors[nCurrentAct]);
			pRoom1 = pRoom1->pNext;
		}
	}
	if (tToggleAutomapActiveRoom.flag) {
		DrlgRoom1 *pRoom1 = D2CLIENT_GetPlayerUnit()->pPos->pRoom1;
		if (pRoom1->nRoomsNear > 0) {
			for (DWORD i = 0; i < pRoom1->nRoomsNear; ++i) {
				RoomPatch2(pRoom1->paRoomsNear[i]->pRoom2,
						anAutomapActiveRoomColors[nCurrentAct]);
			}
		}
	}
	if (tToggleAutomapScreenArea.flag) {
		POINT ptTopLeft, ptTopRight, ptBottomLeft, ptBottomRight;
		ScreenToAutomapRelative(&ptTopLeft, 0, 0);
		ScreenToAutomapRelative(&ptTopRight, D2GetScreenSizeX(), 0);
		ScreenToAutomapRelative(&ptBottomLeft, 0, D2GetScreenSizeY()-48);
		ScreenToAutomapRelative(&ptBottomRight, D2GetScreenSizeX(), D2GetScreenSizeY()-48);
		D2GFX_DrawLine(ptTopLeft.x, ptTopLeft.y, ptTopRight.x, ptTopRight.y, anAutomapScreenColors[nCurrentAct], -1);
		D2GFX_DrawLine(ptBottomLeft.x, ptBottomLeft.y, ptBottomRight.x, ptBottomRight.y, anAutomapScreenColors[nCurrentAct], -1);
		D2GFX_DrawLine(ptTopLeft.x, ptTopLeft.y, ptBottomLeft.x, ptBottomLeft.y, anAutomapScreenColors[nCurrentAct], -1);
		D2GFX_DrawLine(ptTopRight.x, ptTopRight.y, ptBottomRight.x, ptBottomRight.y, anAutomapScreenColors[nCurrentAct], -1);
	}

	if (tToggleMinimap.flag) {
		DrawMinimapLevel(GetUnitDrlgLevel(D2CLIENT_GetPlayerUnit())->nLevelNo);
	}
}

void __declspec(naked) RoomPatch_ASM()
{
	__asm {
		call RoomPatch
		mov ecx, p_D2CLIENT_pAutomapLayer
		mov ecx, [ecx]
		ret
	}
}

void __declspec(naked) MonsterDeathPatch_ASM()
{
	__asm {
		cmp [afMonsterDeathAnims+eax],0
		je noanim
		cmp eax,0x100 //original code
		ret
noanim:
		pop eax // discard return address
		pop esi // restore esi, check prolog of this function carefully
		ret 4 // return to upper level function
	}
}

//monster select name stuff

struct TCTallys {
	int groupnos[5];
	int runeno;
};

BYTE anMonsterTCs[1000];
BYTE anSuperuniqueTCs[100];
int numMonsterTC;
int numSuperuniqueTC;

void GetHighestTC(int tcno, TCTallys *tallys)
{
	TreasureClass *tc = D2COMMON_GetTreasureClasses(tcno, 0);
	if (!tc) return;

	for (int i = 0; i < (int)tc->numitems; i++) {
		if (tc->items[i].tcflag) {
			if (tc->items[i].thingno <= 160) {
				int groupno = (tc->items[i].thingno-1)/32;
				int levno = (((tc->items[i].thingno-1)%32)+1)*3;
				if (levno > tallys->groupnos[groupno]) tallys->groupnos[groupno] = levno;
			} else {
				GetHighestTC(tc->items[i].thingno, tallys);
			}
		} else {
			ItemTxt *itemtxt = D2COMMON_GetItemTxt(tc->items[i].thingno);
			if (itemtxt && itemtxt->nType == 74) {
				int runeno = (itemtxt->szCode[1]-'0')*10+(itemtxt->szCode[2]-'0');
				if (runeno > tallys->runeno) tallys->runeno = runeno;
			}
		}
	}
}

void InitTCList()
{
	MonsterTxt *mon;
	// i < ARRAYSIZE(anMonsterTCs)
	for (int i = 0; mon = D2CLIENT_GetMonsterTxt(i); i++) {
		TCTallys tallys;
		memset(&tallys, 0, sizeof(tallys));
		for (int j = 0; j < 4; j++) {
			int tcno = mon->tcs[D2CLIENT_GetDifficulty()][j];
			GetHighestTC(tcno, &tallys);
		}
		anMonsterTCs[i] = tallys.groupnos[1];
	}
	SuperuniqueTxt *sup;
	// j < ARRAYSIZE(anSuperuniqueTCs)
	for (int j = 0; sup = D2COMMON_GetSuperuniqueTxt(j); j++) {
		TCTallys tallys;
		memset(&tallys, 0, sizeof(tallys));
		int tcno = sup->tcs[D2CLIENT_GetDifficulty()];
		GetHighestTC(tcno, &tallys);
		anSuperuniqueTCs[j] = tallys.groupnos[1];
	}
	numMonsterTC = i;
	numSuperuniqueTC = j;
}

void __fastcall MonsterLifebarNamePatch1(UnitAny *unit, wchar_t *str)
{
	if (tToggleMonsterTC.flag) {
		WORD uniqueno = unit->pMonsterData->pEnchants->uniqueno + 67;
		wsprintfW2(str+wcslen(str)-1, "(tc%d)  ", (uniqueno < 67) ? anSuperuniqueTCs[uniqueno] : anMonsterTCs[unit->nTxtFileNo]);
	}
}

void GetMonsterLevelTC(wchar_t *str, UnitAny *unit, DWORD no)
{
	if (tToggleMonsterLevel.flag) {
		int lvl = D2COMMON_GetUnitStat(unit, STAT_LEVEL, 0);
		if (unit->pMonsterData->fBoss & 1) {
			lvl += 3;
			PBYTE p = unit->pMonsterData->anEnchants;
			for (int i = 0; *p && i < ARRAYSIZE(unit->pMonsterData->anEnchants); ++i, ++p) {
				if (*p == 16 || (*p >= 36 && *p <= 38)) {
					--lvl;
				}
			}
		}
		if (lvl > 99) lvl = 99;
		wsprintfW2(str+wcslen(str), " (l%d)", lvl);
	}
	if (tToggleMonsterTC.flag) {
		BYTE tc;
		if (unit->pMonsterData->fNormal & 1) {
			tc = anSuperuniqueTCs[unit->pMonsterData->uniqueno];
		} else {
			tc = anMonsterTCs[unit->nTxtFileNo];
		}
		if (tc)	wsprintfW2(str+wcslen(str), " (tc%d)", tc);
	}
}

void GetMonsterResists(wchar_t *str, UnitAny *unit, DWORD no)
{
	if (tToggleMonsterResists.flag) {
		int dr = D2COMMON_GetUnitStat(unit, STAT_DAMAGE_REDUCED, 0);
		int mr = D2COMMON_GetUnitStat(unit, STAT_MAGIC_RESIST, 0);
		int fr = D2COMMON_GetUnitStat(unit, STAT_FIRE_RESIST, 0);
		int lr = D2COMMON_GetUnitStat(unit, STAT_LIGHTING_RESIST, 0);
		int cr = D2COMMON_GetUnitStat(unit, STAT_COLD_RESIST, 0);
		int pr = D2COMMON_GetUnitStat(unit, STAT_POSION_RESIST, 0);
		if (dr| mr | fr | lr | cr | pr) {
			wsprintfW2(str+wcslen(str), " (Res:");
			if (dr)	wsprintfW2Colour(str+wcslen(str), 7, " D%d", dr); // Golden
			if (mr)	wsprintfW2Colour(str+wcslen(str), 8, " M%d", mr); // Deep yellow
			if (fr)	wsprintfW2Colour(str+wcslen(str), 1, " F%d", fr); // Red
			if (lr)	wsprintfW2Colour(str+wcslen(str), 9, " L%d", lr); // Light yellow
			if (cr)	wsprintfW2Colour(str+wcslen(str), 3, " C%d", cr); // Blue
			if (pr)	wsprintfW2Colour(str+wcslen(str), 2, " P%d", pr); // Green
			wsprintfW2(str+wcslen(str), ")");
		}
	}
}

UnitAny* FindUnitFromUnitNo(DWORD unitno)
{
	UnitAny *unit = NULL;
	while (unit=D2CLIENT_GetNextPlayer(unit)) {
		if (unit->eMode == unitno) break;
	}
	return unit;
}

BYTE fViewSocketableOn;
BYTE fViewSock_MonLifebarFlag;
BYTE fMonsterLifebarNameOn;
wchar_t szMonsterLifebarName[0x400];
wchar_t szMonsterDesc[0x400*2];
wchar_t* __fastcall MonsterLifebarNamePatch(wchar_t *oldname, DWORD* textsize, DWORD* size, DWORD flag)
{
	if (!oldname) {
		fMonsterLifebarNameOn = 0;
		szMonsterLifebarName[0] = 0;
		return NULL;
	}
	fViewSock_MonLifebarFlag = 1;
	if (!fViewSocketableOn) {
		wcscpy(szMonsterLifebarName, oldname);
	} else {
		wcsrcat(szMonsterLifebarName, L"\n\n");
		wcsrcat(szMonsterLifebarName, oldname);
		if (p_D2CLIENT_pMonsterNameLifePatch1->nTxtFileNo < D2GetTextFileNo(szMonsterLifebarName)) {
			*size = D2GetTextFileNo(szMonsterLifebarName) + p_D2CLIENT_pMonsterNameLifePatch2->nTxtFileNo;
		} else {
			*size = p_D2CLIENT_pMonsterNameLifePatch1->nTxtFileNo;
		}
	}
	UnitAny *unit = D2CLIENT_GetSelectedUnit();
	if (!fMonsterLifebarNameOn && unit) {
		DWORD orilen = wcslen(szMonsterLifebarName);
		DWORD trimlen = orilen;
		if (trimlen > 0) {
			wchar_t *p = &szMonsterLifebarName[trimlen-1];
			while (trimlen > 0 && *p == L' ') {
				-- trimlen;
				*p-- = 0;
			}
		}
		if (unit->nUnitType == UNITNO_MONSTER && !(D2CLIENT_GetMonsterTxt(unit->nTxtFileNo)->flag1b & 2) && D2CLIENT_GetMonsterOwner(unit->nUnitId) == -1) {
			GetMonsterLevelTC(szMonsterLifebarName, unit, 0);
			GetMonsterResists(szMonsterLifebarName, unit, 0);
		}
		if (unit->nUnitType == UNITNO_ITEM && tToggleUnitNumber.flag) {
			DWORD no = 0;
			if (unit->nUnitType == UNITNO_PLAYER) {
				UnitAny *unit2 = FindUnitFromUnitNo(unit->nUnitId);
				if (unit2) no = unit2->unkNo;
			}
			wsprintfW2(szMonsterLifebarName+wcslen(szMonsterLifebarName), " [0x%X,%d]", unit->nUnitId, no ? no : unit->nTxtFileNo);
		}
		DWORD l = orilen - trimlen;
		while (l-- > 0) {
			wcscat(szMonsterLifebarName, L" ");
		}
	}
	if (wcslen(szMonsterLifebarName) >= ARRAYSIZE(szMonsterLifebarName)) {
		wcscpy(szMonsterLifebarName, &szMonsterDesc[wcslen(szMonsterLifebarName)]);
	}
	if (!flag) {
		*textsize += D2GetTextWidth(oldname)/2 - D2GetTextWidth(szMonsterLifebarName)/2;
	}
	fMonsterLifebarNameOn = 1;
	return szMonsterLifebarName;
}

void __declspec(naked) MonsterLifebarNamePatch_ASM()
{
	__asm {
		push edx
		mov edx, esp
		push [esp+0x14]
		lea eax, [esp+0x10]
		push eax
		call MonsterLifebarNamePatch
		mov ecx, eax
		pop edx			// restore edx
		pop eax			// return address
		push ebx
		push esi
		mov esi, ecx
		
		test esi, esi

		jmp eax
	}
}

wchar_t szMonsterDescComma[] = L", ";

void __declspec(naked) MonsterDescCommaPatch1_ASM()
{
	__asm {
		mov eax,offset szMonsterDescComma
		ret
	}
}

void __declspec(naked) MonsterDescCommaPatch2_ASM()
{
	__asm {
		mov edx,offset szMonsterDescComma
		ret
	}
}

void __fastcall MonsterDescCommaPatch3(wchar_t *str, MonsterTxt *montxt)
{
	if (montxt->flag == 0x1506) {
		wcscat(str, szMonsterDescComma);
	}
}

void __declspec(naked) MonsterDescCommaPatch3_ASM()
{
	__asm {
//ecx = ptr string
//[esp+0x20] = ptr monstats.txt
		mov edx,[esp+0x20]
		call MonsterDescCommaPatch3
		mov ecx, [esp+0x20];
		ret
	}
}


//view inventory stuff

class ViewingPlayerInfo
{
public:
	void OpenView();
	void ViewLoop();
	ViewingPlayerInfo():nPlayerId(-1),nUnitType(-1),nUnitNo(-1),vkKeyCode(-1){}
	BOOL TestUnit(UnitAny *unit);
	virtual void CreateUI() = 0;
	virtual void DestroyUI() = 0;
	virtual DWORD GetUI() = 0;
private:
	friend UnitAny * __stdcall ViewingGetUnit(ViewingPlayerInfo* vpi, UnitAny *unitdef);
private:
	DWORD nPlayerId;
	DWORD nUnitType;
	DWORD nUnitNo;
public:
	BYTE  vkKeyCode;
};

BOOL ViewingTestMonster(UnitAny *mon)
{
	DWORD flag = D2CLIENT_GetMonsterTxt(mon->nTxtFileNo)->flag1;
	return (flag&0x1000000) && !(flag&0x200);
}

BOOL ViewingPlayerInfo::TestUnit(UnitAny *unit)
{
	if (unit && unit->pInventory) {
		if (unit->nUnitType == UNITNO_PLAYER) {
			if (vkKeyCode != (BYTE)-1 && unit->eMode) {
				return unit->eMode != 0x11;
			}
		} else if (unit->nUnitType == UNITNO_MONSTER){
			if (vkKeyCode != (BYTE)-1 && unit->eMode && unit->eMode != 0x0C) {
				return ViewingTestMonster(unit) != 0;
			}
		}
	}
	return FALSE;
}


UnitAny * __stdcall ViewingGetUnit(ViewingPlayerInfo* vpi, UnitAny *unitdef)
{
	UnitAny *unitpla = D2CLIENT_GetUnitFromId(vpi->nPlayerId, vpi->nUnitType);
	if (unitpla) {
		if (vpi->nUnitNo != -1) {
			UnitAny *unitmon = D2CLIENT_GetUnitFromId(D2CLIENT_GetInventoryId(unitpla, vpi->nUnitNo, 0), UNITNO_MONSTER);
			return unitmon ? unitmon : unitdef;
		}
		return unitpla;
	}
	return unitdef;
}

class ViewingInventoryInfo : public ViewingPlayerInfo
{
public:
	virtual void CreateUI() { D2CLIENT_SetUiVar(UIVAR_INVENTORY, 0, 1); }
	virtual void DestroyUI() { D2CLIENT_SetUiVar(UIVAR_INVENTORY, 1, 1); }
	virtual DWORD GetUI() { return D2CLIENT_GetUiVar(UIVAR_INVENTORY); }
};

void ViewingPlayerInfo::OpenView()
{
	UnitAny *unitpla = D2CLIENT_GetSelectedUnit();
	if (!unitpla || !TestUnit(unitpla)) return;
	
	CreateUI();

	if (unitpla->nUnitType == UNITNO_MONSTER && (nPlayerId = D2CLIENT_GetMonsterOwner(unitpla->nUnitId)) != -1) {
		nUnitType = 0;
		nUnitNo = D2CLIENT_GetUnitNoFromId(unitpla->nUnitId);
	} else {
		nUnitType = unitpla->nUnitType;
		nUnitNo = -1;
		nPlayerId = unitpla->nUnitId;
	}
}

void ViewingPlayerInfo::ViewLoop()
{
	if (nPlayerId != -1) {
		if (!GetUI() || !TestUnit(ViewingGetUnit(this, NULL))) {
			nPlayerId = -1;
			if (GetUI()) {
				CreateUI();
			}
		}
	}
}

class ViewingStatsInfo : public ViewingPlayerInfo
{
public:
	virtual void CreateUI() { D2CLIENT_SetUiVar(UIVAR_STATS, 0, 1); }
	virtual void DestroyUI() { D2CLIENT_SetUiVar(UIVAR_STATS, 1, 1); }
	virtual DWORD GetUI() { return D2CLIENT_GetUiVar(UIVAR_STATS); }
};

class ViewingSkillsInfo : public ViewingPlayerInfo
{
public:
	virtual void CreateUI() { D2CLIENT_SetUiVar(UIVAR_SKILLS, 2, 1); }
	virtual void DestroyUI() { D2CLIENT_SetUiVar(UIVAR_SKILLS, 1, 1); }
	virtual DWORD GetUI() { return D2CLIENT_GetUiVar(UIVAR_SKILLS); }
};

class ViewingQuestInfo : public ViewingPlayerInfo
{
public:
	virtual void CreateUI() { D2CLIENT_SetUiVar(UIVAR_QUEST, 0, 1); }
	virtual void DestroyUI() { D2CLIENT_SetUiVar(UIVAR_QUEST, 1, 1); }
	virtual DWORD GetUI() { return D2CLIENT_GetUiVar(UIVAR_QUEST); }
};

class ViewingPetInfo : public ViewingPlayerInfo
{
public:
	virtual void CreateUI() { D2CLIENT_SetUiVar(UIVAR_PET, 2, 1); }
	virtual void DestroyUI() { D2CLIENT_SetUiVar(UIVAR_PET, 1, 1); }
	virtual DWORD GetUI() { return D2CLIENT_GetUiVar(UIVAR_PET); }
};



ViewingInventoryInfo viewingInventory;
ViewingStatsInfo viewingStats;
ViewingSkillsInfo viewingSkills;
ViewingPetInfo viewingPet;
ViewingQuestInfo viewingQuestInfo;

ViewingPlayerInfo* viewingList[] = {
	&viewingInventory,
	&viewingStats,
//	&viewingSkills,
//	&viewingPet,
//	&viewingQuestInfo,
};

wchar_t* __fastcall GetUnitText(wchar_t* str, UnitAny* unit)
{
	*str = 0;
	if (unit->nUnitType == UNITNO_PLAYER){
		return wsprintfW2(str, "%s", unit->pPlayerData->szName);
	}
	wchar_t* p = D2LANG_GetLocaleText( D2CLIENT_GetMonsterTxt(unit->nTxtFileNo)->nLocaleTxtNo );
	UnitAny *unit2 = D2CLIENT_GetUnitFromId( D2CLIENT_GetMonsterOwner(unit->nUnitId), 0);
	if (unit2 && unit2 != D2CLIENT_GetPlayerUnit()) {
		return wsprintfW2(str, "%s's %S", unit2->pPlayerData->szName, p);
	}
	return wsprintfW2(str, "%S", p);
}


DWORD __fastcall D2SetTextSize( int pos, wchar_t *str, int count, DWORD maxlen)
{
	static BYTE nTextSize[] = {6,0,7,2,6,1,-1,5,0,-1,-1,0,-1,0,0,0};
	DWORD oldsize = D2WIN_SetTextSize(pos);
	if (count) {
		do {
			D2WIN_SetTextSize(pos);
		} while ( count-- && ((pos=nTextSize[pos]) != -1) && D2GetTextWidth(str) > maxlen);
	}
	while (D2GetTextWidth(str) > maxlen) {
		str[wcslen(str)-1] = 0;
		maxlen -= 8;
	}
	wcscat(str, L"...");
	return D2WIN_SetTextSize(oldsize);
}

UnitAny *ViewInventoryPatch1()
{
	UnitAny *unitpla = ViewingGetUnit(&viewingInventory,D2CLIENT_GetPlayerUnit());
	if (unitpla != D2CLIENT_GetPlayerUnit()) {
		wchar_t temp[80];
		wchar_t *p = GetUnitText(temp, unitpla);
		D2DrawCenterText(D2SetTextSize(1, p, -1, sizeof(temp)), p, D2GetScreenOffsX()+484, D2GetScreenOffsY()+236, 0);
	}
	return unitpla;
}

void __declspec(naked) ViewInventoryPatch1_ASM()
{
	__asm {
		push eax;
		call ViewInventoryPatch1;
		mov esi, eax;
		pop eax;
		ret;
	}
}

UnitAny* GetViewingInventoryPlayer()
{
	return ViewingGetUnit(&viewingInventory,D2CLIENT_GetPlayerUnit());
}

void __declspec(naked) ViewInventoryPatch2_ASM()
{
	__asm {
		push eax;
		call GetViewingInventoryPlayer;
		mov ebx, eax;
		pop eax;
		ret;
	}
}

UnitAny* GetViewingStatsPlayer()
{
	return ViewingGetUnit(&viewingStats,D2CLIENT_GetPlayerUnit());
}

UnitAny* GetViewingSkillsPlayer()
{
	return ViewingGetUnit(&viewingSkills,D2CLIENT_GetPlayerUnit());
}

UnitAny* GetViewingPet()
{
	return ViewingGetUnit(&viewingPet,D2CLIENT_GetPlayerUnit());
}

UnitAny* GetViewingQuestInfo()
{
	return ViewingGetUnit(&viewingQuestInfo,D2CLIENT_GetPlayerUnit());
}

void __declspec(naked) GetViewingStatsPlayerPatch3_ASM()
{
	__asm {
		push eax
		call GetViewingStatsPlayer
		cmp ebx,eax
		pop eax
		ret;
	}
}

void __declspec(naked) GetViewingStatsPlayerPatch4_ASM()
{
	__asm {
		push eax
		call GetViewingStatsPlayer
		mov esi,eax
		pop eax
		ret;
	}
}

void __declspec(naked) ViewInventoryPatch3_ASM()
{
	__asm {
//edi = default unit
		push eax
		mov eax, p_D2CLIENT_PlayerUnit
		mov eax, [eax]
		cmp edi, eax
		jnz viewinvold
		push edi
		lea eax, viewingInventory;
		push eax
		call ViewingGetUnit
		mov edi,eax
viewinvold:
		pop eax
//original code
		test eax,eax
		mov ecx, [edi+0x60]
		ret
	}
}

void __declspec(naked) SocketProtectPatch_ASM()
{
	__asm {
		mov eax, p_D2CLIENT_PlayerUnit
		mov eax, [eax]
		push 0x13
		push eax
		call D2CLIENT_SocketProtect_ORIG
		ret
	}
}

DWORD ViewInventoryPatch4()
{
	if (ViewingGetUnit(&viewingInventory, NULL)) {
		SocketProtectPatch_ASM();
		return 1;
	}
	return 0;
}

void __declspec(naked) ViewInventoryPatch4_ASM()
{
	__asm {
		call ViewInventoryPatch4
		test eax, eax
		jz oldcode
		add dword ptr [esp], 0xE1
		ret 4
oldcode:
		push [esp+4]
		call D2COMMON_GetCursorItem
		ret 4
	}
}

void __declspec(naked) __fastcall SocketViewtableCallRoutine(UnitAny *unit, DWORD arg, void (__stdcall *func)(UnitAny*, DWORD))
{
	__asm {
		mov eax, 0x6654
		push edx
		push ecx
		call [esp+0x0c]
		ret 4
	}
}

void __stdcall SocketViewtablePatch(void (__stdcall *func)(UnitAny*, DWORD), UnitAny *u, DWORD arg)
{
	fViewSock_MonLifebarFlag = 0;
	SocketViewtableCallRoutine(u, arg, func);
	if (fViewSock_MonLifebarFlag && tToggleViewSocketable.flag)	{
		fViewSocketableOn = 1;
		UnitAny *unit = D2CLIENT_pInSocketablePatch;
		if (unit && unit->pInventory) {
			DWORD n = D2COMMON_GetItemFromInventory(unit->pInventory);
			while (n) {
				D2CLIENT_pInSocketablePatch = D2COMMON_GetUnitFromItem(n);
				SocketViewtableCallRoutine(unit, 1, func);
				n = D2COMMON_GetNextItemFromInventory(n);
			}
		}
		fViewSocketableOn = 0;
		D2CLIENT_pInSocketablePatch = unit;
	}
}

void __declspec(naked) SocketViewtablePatch_ASM()
{
	__asm {
		pop eax // exchange return address
		pop ecx
		push eax
		push ecx
		jmp SocketViewtablePatch
	}
}

void __declspec(naked) SocketViewtablePatch2_ASM()
{
	__asm {
		cmp fViewSocketableOn, 0
		jz outcode
		pop esi // discard my return adress
		pop esi // restore esi
		pop ebx // restore ebx
		ret
outcode:
		mov ecx, 0xF9E
		ret
	}
}

void __declspec(naked) ItemBasicStatPatch_ASM()
{
	__asm {
		cmp [tToggleItemBasicStat.flag], 0
		jz callcode
		xor eax, eax
		jmp quitcode
callcode:
		push dword ptr [esp+4]
		call D2COMMON_GetItemFromInventory
quitcode:
		ret 4
	}
}


BYTE fPlayerInTown;
void __declspec(naked) OutTownSelectPatch1_ASM(/* four args on the stack*/)
{
	__asm {
		push [esp+0x14] // parameter 4
		push [esp+0x14] // parameter 3
		push [esp+0x14] // parameter 2
		push [esp+0x14] // parameter 1
		push outcode
//original code
		sub esp, 0x20
		push ebp
		xor ebp, ebp
		/* esp adjustment sum up
		 *	push ebp		== 4
		 *	sub esp, 0x20	== 0x20
		 *	5 push insts	== 0x14
		 */
		jmp dword ptr [esp+4+0x20+0x14] //TODO:check this function carefully
outcode:
		mov fPlayerInTown, 0
		add esp, 4
		ret 0x10
	}
}

int __fastcall OutTownSelectPatch2(UnitAny *unit)
{
	if (!fPlayerInTown && viewingInventory.TestUnit(unit)) {
		if (tToggleOutTownSelect.flag || TestPlayerInTown(unit))
			return 1;
	}
	return -1;
}

void __declspec(naked) OutTownSelectPatch2_ASM()
{
	__asm {
		shr eax, 0x15
		and eax, 1
		jnz donothing
		mov ecx, ebp
		call OutTownSelectPatch2;
		cmp al, 0xFF
		jz quitcode
		add dword ptr [esp], 0xA2 // adjust return address
		mov [esp+4+0x34], eax // save return result
		pop eax // return address to eax
		push esi // push esi and edi because the return address skips these two instructions
		push edi
		jmp eax
donothing:
		ret
quitcode:
		xor eax, eax
		ret
	}
}

void __declspec(naked) OutTownSelectPatch3_ASM()
{
	__asm {
		cmp fPlayerInTown, 0
		jz outcode
		mov ecx, ebp
		call InfravisionPatch3
		cmp al, 1
		ret
outcode:
		shr eax, 7
		and eax, 1
		ret
	}
}

void __declspec(naked) SocketProtectPatch1_ASM()
{
	__asm {
		cmp tToggleSocketProtect.flag, 0
		jz outcode
		call SocketProtectPatch_ASM
		add dword ptr [esp], 0x47 //TODO:check if the return address is correct (should return to 6FB64130)
		ret
outcode:
// original code
		mov eax, [esp+4+0x18] // check if the offset is correct (at 6FB640E4)
		test eax, eax
		ret
	}
}

void __declspec(naked) SocketProtectPatch2_ASM()
{
	__asm {
		cmp tToggleSocketProtect.flag, 0
		jz outcode
		call SocketProtectPatch_ASM
		add dword ptr [esp], 0x36
		ret
outcode:
		mov eax, [esp+4+0x44] // 4 bytes for return address
		test eax, eax
		ret
	}
}

//misc patchs stuff

BYTE fAutomapPartyDefault = 1, fAutomapNamesDefault = 1;

void __fastcall CowLevelQuestPatch(int ypos, int xpos)
{
	if (!D2CLIENT_nQuestPage) {
		int cow = D2COMMON_GetQuestFlag(D2CLIENT_GetQuestInfo(), 4, 10);
		if (cow) D2DrawCenterText(8, L"X", 307+xpos, 48-ypos, cow?1:2);
	}
}

void __declspec(naked) CowLevelQuestPatch_ASM()
{
	__asm {
		call CowLevelQuestPatch
//original code
		cmp esi,0x116
		ret
	}
}

BOOL PermShowItemsPatch()
{
	return tTogglePermShowItems.flag || D2CLIENT_GetUiVar(UIVAR_SHOWITEMS);
}

void __declspec(naked) PermShowItemsPatch_ASM()
{
	__asm {
		call PermShowItemsPatch
		test eax,eax
		ret
	}
}

void __declspec(naked) PermShowItemsPatch2_ASM()
{
	__asm {
		push eax
		call PermShowItemsPatch
		mov ecx, eax
		pop eax
		ret
	}
}

BOOL CheckSpecialUiVars()
{
	static BYTE nums[] = {1, 2, 3, 4, 5, 9, 0x0B, 0x0F, 0x16, 0x21};
	for( int i = 0; i < ARRAYSIZE(nums); ++i) {
		if (D2CLIENT_GetUiVar(nums[i]))
			return TRUE;
	}
	return FALSE;
}

void __declspec(naked) CheckSpecialUiVarsPatch_ASM()
{
	__asm {
		call CheckSpecialUiVars
		test eax,eax
		ret
	}
}


BOOL __stdcall CheckUiVar_11(DWORD no)
{
	if (D2GFX_GetScreenSize()) {
		return D2CLIENT_GetUiVar(no);
	}
	return FALSE;
}

void __declspec(naked) CheckUiVar_11_Patch_ASM()
{
	__asm {
		push 0x11
		call CheckUiVar_11
		test eax,eax
		ret
	}
}

//game init stuff

DWORD nTickCount;

void SaveTickCount()
{
	nTickCount = GetTickCount();
}

void __fastcall GameTimePatch(DWORD size)
{
	wchar_t buf[512];
	int ypos = D2CLIENT_yPosition;
	if (tToggleGameTime.flag) {
		DWORD secs = (GetTickCount() - nTickCount)/1000;
		wsprintfW2(buf,"%.2d:%.2d:%.2d", secs/3600, (secs/60)%60, secs%60);
		D2DrawCenterText( 8, buf, D2GetScreenSizeX()-16, ypos, 4, 0);
		ypos += 16;
	}
	if (tToggleClock.flag) {
		SYSTEMTIME t;
		GetLocalTime(&t);
		wsprintfW2(buf, "%.2d:%.2d:%.2d", t.wHour, t.wMinute, t.wSecond );
		D2DrawCenterText( 8, buf, D2GetScreenSizeX()-16, ypos, 4, 0);
		ypos += 16;
	}

	if (tToggleLayerLevelNo.flag) {
		wsprintfW2(buf, "Layer No: %d", D2CLIENT_pAutomapLayer->nLayerNo);
		D2DrawCenterText( 8, buf, D2GetScreenSizeX()-16, ypos, 4, 0);
		ypos += 16;

		wsprintfW2(buf, "Level No: %d", GetUnitDrlgLevel(D2CLIENT_GetPlayerUnit())->nLevelNo);
		D2DrawCenterText( 8, buf, D2GetScreenSizeX()-16, ypos, 4, 0);
		ypos += 16;
	}

	GameStructInfo *gi = D2CLIENT_GetGameInfo();
	if(tToggleServerIp.flag && *gi->szGameServerIp)
	{
		wsprintfW2(buf, "%s", gi->szGameServerIp);
		D2DrawCenterText( 8, buf, D2GetScreenSizeX()-16, ypos, 4, 0);
	}
	D2WIN_SetTextSize(size);
}

void ResetGameShutdownFlag()
{
	fGameShutdow = 0;
}

UnitAny* GetNearbyUnit(DWORD unitid, DWORD unittype)
{
	UnitAny *unit = D2CLIENT_GetUnitFromId(unitid, unittype);
	if (unit) {
		DrlgRoom1 *room1 = D2CLIENT_GetPlayerUnit()->pPos->pRoom1;
		DWORD nRoomsNear = room1->nRoomsNear;
		if (nRoomsNear > 0) {
			DrlgRoom1 **pp = room1->paRoomsNear;
			for (DWORD n = 0; n < nRoomsNear; ++n, ++pp) {
				if (unit->pPos->pRoom1 == *pp)
					return unit;
			}
		}
	}
	return NULL;
}

unsigned int nChickenLife;
unsigned int nChickenHostileLife;
unsigned int nChickenHostileNearbyLife;
unsigned int nChickenLifePercent;
unsigned int nChickenHostileLifePercent;
unsigned int nChickenHostileNearbyLifePercent;
void ChickenLife()
{
	if (fGameShutdow || TestPlayerInTown(D2CLIENT_GetPlayerUnit())) return;
	unsigned int life = D2COMMON_GetUnitStat(D2CLIENT_GetPlayerUnit(), STAT_LIFE, 0);
	if (!life) return;
	life >>= 8; // actual life
	unsigned int maxlife = D2COMMON_GetUnitStat(D2CLIENT_GetPlayerUnit(), STAT_MAXLIFE, 0);
	maxlife >>= 8;
	
	if (tToggleChickenLife.flag && ((nChickenLife && life <= nChickenLife) || (nChickenLifePercent && life*100 <= maxlife*nChickenLifePercent) )) {
		ChickenQuit(L"<Hackmap>: Life below chicken threshold, exiting game.");
	} else {
		for (UnitAny *unit = D2CLIENT_GetNextPlayer(NULL); unit; unit = D2CLIENT_GetNextPlayer(unit)) {
			if (D2CLIENT_TestPvpFlag(unit->eMode, D2CLIENT_GetPlayerUnit()->nUnitId, 8)) {
				if (tToggleChickenHostile.flag && ((nChickenHostileLife && life <= nChickenHostileLife) || (nChickenHostileLifePercent && life*100 <= maxlife*nChickenHostileLifePercent)) ) {
					ChickenQuit(L"<Hackmap>: Life below chicken hostile threshold, exiting game.");
					break;
				}
				if (tToggleChickenHostileNearby.flag && ((nChickenHostileNearbyLife && life <= nChickenHostileNearbyLife) || (nChickenHostileNearbyLifePercent && life*100 <= maxlife*nChickenHostileNearbyLifePercent)) && GetNearbyUnit(unit->nOwnerId, 0)) {
					ChickenQuit(L"<Hackmap>: Life below chicken hostile nearby threshold, exiting game.");
					break;
				}
			}
		}
	}
}

D2EditBox* pD2WinEditBox;
void CheckD2WinEditBox()
{
	if (pD2WinEditBox) {
		if (D2CLIENT_GetUiVar(UIVAR_CHATINPUT)) {
			if( *(DWORD*)p_D2CLIENT_szLastChatMessage != 0xAD5AFFFF) {
				D2WIN_DestroyEditBox(pD2WinEditBox);
				pD2WinEditBox = NULL;
				D2WIN_pFocusedControl = NULL;
			}
			D2WIN_SetTextSize(1);
		}
	}
}

BOOL __cdecl InputLinePatch(BYTE keycode)
{
	if (tToggleInputLine.flag && keycode != VK_ESCAPE) {
		if (keycode != VK_RETURN) return TRUE;
		if (pD2WinEditBox) {
			wcscpy(p_D2CLIENT_szLastChatMessage, D2WIN_GetEditBoxText(pD2WinEditBox));
		}
	}
	return FALSE;
}

void __declspec(naked) InputLinePatch_ASM()
{
	__asm {
		mov ebx, eax
		push [edi+8]
		call InputLinePatch
		test eax, eax
		pop eax
		jz quitcode
		add dword ptr [esp], 0x427 // add to the point where function returns
quitcode:
		ret
	}
}

BOOL __stdcall EditBoxCallBack(D2EditBox* hwnd, DWORD arg2, DWORD arg3)
{
	return TRUE;
}

BOOL __cdecl InitD2EditBox()
{
	if (!tToggleInputLine.flag) return FALSE;
	if(!pD2WinEditBox) {
		static DWORD dws[] = {0x0D, 0};
		pD2WinEditBox = D2WIN_CreateEditBox(0x83,
			D2GetScreenSizeY()-58, D2GetScreenSizeX()-266,
			0x2D,
			0, 0, 0, 0, 0,
			sizeof(dws), &dws
			);
		D2WIN_pFocusedControl = pD2WinEditBox;
		if (pD2WinEditBox) {
			D2WIN_SetEditBoxProc(pD2WinEditBox, &EditBoxCallBack);
			D2WIN_SetEditBoxText(pD2WinEditBox, p_D2CLIENT_szLastChatMessage);
		}
		*(DWORD*)p_D2CLIENT_szLastChatMessage = 0x0AD5AFFFF;
	}
	if (pD2WinEditBox)
		(pD2WinEditBox->func)(pD2WinEditBox);
	return TRUE;
}

void __declspec(naked) InputLinePatch2_ASM()
{
	__asm {
		call InitD2EditBox
		test eax, eax
		jz quitcode
		add dword ptr [esp], 0x154
quitcode:
		mov ecx, p_D2CLIENT_szLastChatMessage
		ret
	}
}

void __declspec(naked) PermShowOrbPatch_ASM()
{
	__asm {
		cmp [tTogglePermShowOrb.flag], 0
		jz nextcode
		add dword ptr [esp], 0x25
		ret
nextcode:
		call D2GetScreenSizeY
		cmp ebx, 0x1E
		ret
	}
}

void __declspec(naked) PermShowOrbPatch2_ASM()
{
	__asm {
		and word ptr [esp+0x18], 0
		ret
	}
}

void __declspec(naked) PermShowOrbPatch3_ASM()
{
	__asm {
		cmp [tTogglePermShowOrb.flag], 0
		jz nextcode
		add dword ptr [esp], 0x2D
		ret
nextcode:
		call D2GetScreenSizeX
		mov ecx, eax
		call D2GetScreenSizeY
		ret
	}
}

void __declspec(naked) GameTimeClockPatch()
{
	__asm {
		mov al, tToggleGameTime.flag
		mov cl, tToggleClock.flag
		neg al
		sbb eax, eax
		and eax, 0x10
		neg cl
		sbb ecx, ecx
		and ecx, 0x10
		add eax, ecx
		mov ecx, p_D2CLIENT_yPosition // FIXME
		mov ecx, [ecx]
		lea eax, [eax+ecx-0x10]
		ret
	}
}

void __declspec(naked) GameTimeClockPatch_ASM()
{
	__asm {
		call GameTimeClockPatch
		mov edi, eax
		ret
	}
}

void __declspec(naked) GameTimeClockPatch2_ASM()
{
	__asm {
		call GameTimeClockPatch
		add eax, 0x46
		add esi, eax
		ret
	}
}

void __fastcall D2LogMessage(wchar_t* wstr)
{
	char buf[0x400];
	char c;
	c = 0;
	char *p = buf;
	for (wchar_t *pw = wstr;*pw; ++pw) {
		if (*pw == 0xFF)
			c = 3;
		if (c != 0) --c;
		else {
			*p++ = *(char*)pw;
		}
	}
	*p++ = '\r';
	*p++ = '\n';
	*p = '\0';

	HANDLE hFile = OpenFileWrite("d2messages.log");
	SetFilePointer(hFile, 0, 0, FILE_END);
	WriteFile(hFile, buf, strlen(buf));
	CloseHandle(hFile);
}

BYTE fLogInGameMessage = 0;
void __declspec(naked) MessageLogPatch1_ASM()
{
	__asm {
		cmp [fLogInGameMessage],0
		je oldcode
		mov ecx, esi
		call D2LogMessage
oldcode:
		mov ecx, 0x0D
		jmp D2WIN_SetTextSize
	}
}

void __declspec(naked) MessageLogPatch2_ASM()
{
	__asm {
		cmp [fLogInGameMessage],0
		je oldcode
		mov ecx, ebp
		call D2LogMessage
oldcode:
		mov ecx, 0x0D
		jmp D2WIN_SetTextSize
	}
}

wchar_t wszGameName[32];
void D2QuickNextGame()
{
	wchar_t *nptr = wszGameName+wcslen(wszGameName)-1;
	wchar_t *endptr = nptr+1;
	while (nptr >= wszGameName && (*nptr == L'0' || iswdigit(*nptr))) {
		--nptr;
	}
	if (nptr < endptr-1) {
		long n = wcstol(++nptr, &endptr, 10);
		wchar_t temp[32];
		wsprintfW(temp, L"%d", ++n);
		wchar_t *nptr2 = endptr-wcslen(temp);
		if (nptr < nptr2) nptr = nptr2;
		wcscpy(nptr, temp);
	}

	D2ExitGame(0);
}

BYTE fAutoNextGameName = 1;
BYTE fAutoNextGamePassword;
wchar_t wszGamePassword[32];
void __fastcall NextGameNamePatch(D2EditBox* box, BOOL (__stdcall *FunCallBack)(D2EditBox*,DWORD,DWORD))
{
	if (!fAutoNextGameName) return;

	D2WIN_SetEditBoxText(box, wszGameName);
	D2WIN_SelectEditBoxText(box);
	// original code
	D2WIN_SetEditBoxProc(box, FunCallBack);
}
void __fastcall NextGamePasswordPatch(D2EditBox* box, BOOL (__stdcall *FunCallBack)(D2EditBox*,DWORD,DWORD))
{
	if (!fAutoNextGamePassword) return;

	D2WIN_SetEditBoxText(box, wszGamePassword);
	D2WIN_SelectEditBoxText(box);
	// original code
	D2WIN_SetEditBoxProc(box, FunCallBack);
}

void SaveGameName()
{
	GameStructInfo *gi = D2CLIENT_GetGameInfo();
	if(*gi->szGameName) {
		wcscpy2(wszGameName, gi->szGameName);
		wcscpy2(wszGamePassword, gi->szGamePassword);
	}
}

void SetCurrentPlayerStat(int inc);
void ResetMinimapCells();
void ResetPacketRecvIntercept();
void InstallPatchs2();
BYTE fEnterGameSound;
BYTE fAutoRevealAct;
BYTE fGameInitDone = 0;
BYTE fWindowMode;
void GameLoopPatch()
{
	wchar_t temp[512];
	if (!fGameInitDone) {
		DestroyMyAutomapCells();
		InstallPatchs2();

		fGameInitDone = 1;
#ifdef ENABLE_CATCH_EXECEPTION
		SetDbgUnexpectedHandler(TRUE);
#endif

		wsprintfW2(temp, "<Hackmap>: %s installed.", szProgTitle);
		D2CLIENT_PrintGameStringAtTopLeft(temp, 0);

		InitShrines();
		InitItemColours();
		InitBlobs();
		InitTCList();
		ResetMinimapCells();
		if(fEnterGameSound)
			MessageBeep(MB_ICONEXCLAMATION);

		SaveTickCount();
		SaveGameName();
		ResetGameShutdownFlag();
		SetCurrentPlayerStat(0);
		memset(afRevealedActs, 0, sizeof(afRevealedActs));
	}

#if 0
	for (int j = 0; j < 0x26; j++) {
		if (p_D2CLIENT_UiVarArray[j]) {
			switch(j) {
			case 0:
			case 6:
			case 7:
			case 19:
			case 35:
				break;
			default:
				{
					char szInfo[100];
					wsprintf(szInfo, "Active UIVAR; %u\n", j);
					OutputDebugString(szInfo);
				}
				break;
			}
		}
	}
#endif

	for (int i = 0; i < ARRAYSIZE(viewingList); i++) {
		viewingList[i]->ViewLoop();
	}

	if(fBackToTown && TestPlayerInTown(D2CLIENT_GetPlayerUnit()))
	{
		ResetPacketRecvIntercept();
	}
	
	ChickenLife();
	CheckD2WinEditBox();
	DWORD act = GetCurrentAct(GetUnitDrlgLevel(D2CLIENT_GetPlayerUnit()))-1;
	nCurrentAct = act < 0 ? 0 : act;
	if (fAutoRevealAct && !afRevealedActs[nCurrentAct]) {
		RevealAutomapAct();
	}
}

void __declspec(naked) GameLoopPatch_ASM()
{
	__asm {
		pop eax
		sub esp, 0x20
		mov [esp+0x0c], ecx
		push eax
		jmp GameLoopPatch
	}
}

void GameEndPatch2()
{
	if (pD2WinEditBox) {
		*(DWORD*)p_D2CLIENT_szLastChatMessage = 0;
		wchar_t *p = wcscpy(p_D2CLIENT_szLastChatMessage, D2WIN_GetEditBoxText(pD2WinEditBox));
		D2CLIENT_nTextLength = wcslen(p);
		D2WIN_DestroyEditBox(pD2WinEditBox);
		pD2WinEditBox = NULL;
		D2WIN_pFocusedControl = NULL;
	}
}

void GameEndPatch()
{
	if (fGameInitDone) {
		fGameInitDone = 0;

		RemoveMyAutomapCells();
		DestroyMyAutomapCells();

		DeleteShrines();
		DeleteBlobs();
		GameEndPatch2();
	}
}

void __declspec(naked) GameEndPatch_ASM()
{
	__asm {
		call GameEndPatch
//original code
		mov ecx,0xb4
		ret
	}
}

struct PlayerStat {
	DWORD stat;
	char* desc;
}aPlayerStats[] = {
	{STAT_MAGIC_FIND, "Magic Find"},
	{STAT_EXTRA_GOLD, "Extra Gold"},
	{STAT_IAS, "Increased Attack Speed"},
	{STAT_FCR, "Faster Cast Rate"},
	{STAT_FBR, "Faster Block Rate"},
	{STAT_FHR, "Faster Hit Recovery"},
	{STAT_FRW, "Faster Run/Walk"},
	{STAT_LIFE_LEECH, "Life Leech"},
	{STAT_MANA_LEECH, "Mana Leech"},
	{STAT_DAMAGE_REDUCED, "Damage Reduced"},
	{STAT_MAGIC_DAMAGE_REDUCED, "Magic Damage Reduced"},
	{STAT_LIGHTING_ABSORB, "Lighting Absorb"},
	{STAT_FIRE_ABSORB, "Fire Absorb"},
	{STAT_COLD_ABSORB, "Cold Absorb"},
	{STAT_MANA_AFTER_EACH_KILL, "Mana After Each Kill"},
	{STAT_DAMAGE_TAKEN_GOES_TO_MANA, "Damage Taken Goes to Mana"},
//	{STAT_MAGIC_ABSORB, "Magic Absorb"},
//	{STAT_MAGIC_RESIST, "Magic Resist"},
//	{STAT_DEADLY_STRIKE, "Deadly Strike"},
//	{STAT_PIERCING_ATTACK, "Piercing Attack"},
//	{STAT_BLESSED_AIM, "Blessed Aim"},
//	{STAT_REGENERATE_MANA, "Regenerate Mana"}
};

BYTE vkFirstPlayerStat = -1;
BYTE vkNextPlayerStat = -1;
BYTE vkPrevPlayerStat = -1;
int nCurrentPlayerStat = 0;
void SetCurrentPlayerStat(int inc)
{
	if (!inc) nCurrentPlayerStat = 0;
	else {
		nCurrentPlayerStat += inc;
		if (nCurrentPlayerStat < 0 ) nCurrentPlayerStat = ARRAYSIZE(aPlayerStats)-1;
		else if (nCurrentPlayerStat >= ARRAYSIZE(aPlayerStats)) nCurrentPlayerStat = 0;
	}
}

void D2QuickNextGame();
//keydown stuff

void __fastcall KeydownPatch(BYTE keycode, BYTE repeat)
{
	if ((keycode == (BYTE)-1) || !keycode) return;

	if (keycode == VK_LEFT) ScrollMap(-2, 0);
	if (keycode == VK_RIGHT) ScrollMap(+2, 0);
	if (keycode == VK_UP) ScrollMap(0, -2);
	if (keycode == VK_DOWN) ScrollMap(0, +2);
	if (tToggleDiagonalScroll.flag) {
		if (keycode == VK_HOME) ScrollMap(-2, -1);
		if (keycode == VK_END) ScrollMap(-2, +1);
		if (keycode == VK_PRIOR) ScrollMap(+2, -1);
		if (keycode == VK_NEXT) ScrollMap(+2, +1);
	}

	if (repeat) return;

	if (keycode == vkRevealAct) RevealAutomapAct();
	if (keycode == vkRevealLevel) RevealAutomapLevel();
	if (keycode == vkCenterMap) CenterMap();
	if (keycode == vkExitGame) D2ExitGame(0);
	if (keycode == vkQuickNextGame) D2QuickNextGame();
	if (keycode == vkBackToTown || fBackToTown == 2) {
		fBackToTown = 0;
		BackToTown();
	}

	if (keycode == vkFirstPlayerStat) SetCurrentPlayerStat(0);
	if (keycode == vkNextPlayerStat) SetCurrentPlayerStat(1);
	if (keycode == vkPrevPlayerStat) SetCurrentPlayerStat(-1);
	for (int i = 0; i < ARRAYSIZE(viewingList); i++) {
		if (keycode == viewingList[i]->vkKeyCode)
			viewingList[i]->OpenView();
	}
	

	char buf[512];
	buf[0] = '\0';
	ToggleVar *tv = &pTogglesListStart;
	while (tv <= &pTogglesListEnd) {
		if (keycode == tv->key) {
			tv->flag = !tv->flag;
			if (tv->func) (tv->func)();
			if (tv->desc)
				wsprintfA(buf+strlen(buf), ", %s %s", tv->desc, tv->flag ? "on" : "off");
		}
		tv++;
	}
	if (buf[0] != '\0') {
		wchar_t wbuf[512];
		D2CLIENT_PrintGameStringAtBottomLeft(wsprintfW2(wbuf, "<Hackmap>: %s.", &buf[2]), 0);
	}
}

void __declspec(naked) KeydownPatch_ASM()
{
	__asm {
//edi = ptr to (hwnd, msg, wparam, lparam)
		mov cl,[edi+0x08] //nVirtKey (wparam)
		mov dl,[edi+0x0c+3] //lKeyData (lparam)
		and dl,0x40 //bit 30 of lKeyData (lparam)
		call KeydownPatch
//original code
		test byte ptr [edi+0x0c+3],0x40 //bit 30 of lKeyData (lparam)
		ret
	}
}

//int statn = -2;
int GetPlayerStat(UnitAny *unit)
{
	if (!unit) return 0;

	return D2COMMON_GetUnitStat(unit, aPlayerStats[nCurrentPlayerStat].stat, 0);
	
	// old MP code
//	int n1 = D2COMMON_GetUnitStat(unit, 0xF0, 0);
//	int n2 = D2COMMON_GetUnitStat(unit, STAT_LEVEL, 0);
//	int n3 = D2COMMON_GetUnitStat(unit, STAT_MAGIC_FIND, 0);
//	return n1*n2+n3;
}

void ViewPlayerStatPatch()
{
	wchar_t temp[256];
	UnitAny *unitpla = ViewingGetUnit(&viewingStats, D2CLIENT_GetPlayerUnit());
	int pla = GetPlayerStat(unitpla);
	UnitAny *unit = D2CLIENT_GetUnitFromId(D2CLIENT_GetInventoryId(unitpla, 7, 0), 1);
	int pet = GetPlayerStat(unit);

	wsprintfW2(temp, "%s", aPlayerStats[nCurrentPlayerStat].desc);
	D2DrawText( 6, temp, D2GetScreenOffsX()+16, D2GetScreenOffsY()+380, 0);
	if (aPlayerStats[nCurrentPlayerStat].stat != STAT_MAGIC_DAMAGE_REDUCED)
		wsprintfW2(temp, "%d%% %d%%", pla, pet);
	else
		wsprintfW2(temp, "%d %d", pla, pet);
	D2DrawText( 6, temp, D2GetScreenOffsX()+16, D2GetScreenOffsY()+380+12, 0);
}

void __declspec(naked) ViewPlayerStatPatch_ASM()
{
	__asm {
		call ViewPlayerStatPatch
		add esp, 0x370
		ret
	}
}

void __declspec(naked) PassingActBugFixPatch_ASM()
{
		__asm {
		test edi, edi;
		jz retcode;
//oldcode
		rep stosd;
		mov ecx, edx;
		and ecx, 3;
		rep stosb;
retcode:
		ret;
	}
}

void __stdcall DecodeWardenMethodsPatch()
{
	LPBYTE pWardenInterface = D2CLIENT_pWardenInterface;
	int i = 0;
}

void __declspec(naked) DecodeWardenMethodsPatch_ASM()
{
//ecx=code size
//[esp+4]=warden code
//[esp+8]=hase key
	__asm {
		push [esp+8];
		push [esp+8];
		call D2CLIENT_DecodeWardenMethods_I;
		call DecodeWardenMethodsPatch;
		ret 8;
	}
}

void __declspec(naked) CommonUnloadMyself_ASM()
{
	__asm {
		push hInstDLL;			// parameter of FreeLibrary
		lea eax, [esp+4];		// load return address of FreeLibrary
		push eax;				// return address of FreeLibrary
		push FreeLibrary;		// function to call
		ret;					// call FreeLibrary to unload myself
	}
}

void DumpWardenMod(LPVOID pData, DWORD cbSize, DWORD crcval)
{
	char filename[MAX_PATH], postfix[64];
	sprintf(postfix, "warden_%08x.map", crcval);
	strcpy(GetMyFileNameStrrchr(filename, '\\'), postfix);
	HANDLE hFile = 	CreateFile(filename, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		WriteFile(hFile, pData, cbSize);
		CloseHandle(hFile);
	}
}

DWORD nWardenSigNum = 0;
LPDWORD pWardenSig = NULL;
BYTE fSafeWardenMod;
BYTE fWardenAction = 1;
BOOL __stdcall InvestigateWarden(LPDWORD pRawCode, WardenClient_t *piWarden)
{
	if (fWardenAction == 0)
		return TRUE;

	BOOL retval = FALSE;
	fSafeWardenMod = 0;
	__try {
		SMemBlock_t *pSMemBaseAddr = DATAPTR_TO_SMEMPTR(pRawCode);
		unsigned long crcval = crc32((unsigned char*)pRawCode, pSMemBaseAddr->cbSize);
		if (0xc1c00f59 == crcval) {
			fSafeWardenMod = 1;
			retval = TRUE;
		}
		else {
			for (DWORD i = 0; i < nWardenSigNum; i++)
			{
				if (pWardenSig[i] == crcval) {
					retval = TRUE;
					fSafeWardenMod = 1;
					break;
				}
			}
		}
		if (!retval) {
			DEBUGMSG("unknown warden mod. crc=%08x\n", crcval);
			if (fWardenAction == -1)
				DumpWardenMod(piWarden->pWardenRegion, piWarden->cbSize, crcval);
		}
	} __except(EXCEPTION_EXECUTE_HANDLER) {
	}
	return retval;
}

void __declspec(naked) InitWardenModPatch_ASM()
{
//esi=warden interface
//ecx=raw code
	__asm {
		push ecx; // save ecx
		push esi; // parameter of D2CLIENT_InitWardenInterface_I
		call D2CLIENT_InitWardenInterface_I;
		pop ecx; // restore ecx
		push eax; // save return value
		push esi; // parameter 2
		push ecx; // parameter 1
		call InvestigateWarden;
		test eax, eax;
		jz unloadmyself;
		//safe warden
		pop eax; // restore return value
		ret 4;
unloadmyself:
		mov eax, dword ptr [esp+4]; // return addr -> eax
		mov dword ptr[esp+8], eax; // adjust return addr location
		pop eax; // restore return value
		mov dword ptr [esp], eax;

		// pop eax, pop eax, ret, int 3
		push 0xccc35858;		// prepare code for FreeLibrary returning
		jmp CommonUnloadMyself_ASM;
	}
}

void ShowUnloadMessage()
{
	D2CLIENT_PrintGameStringAtTopLeft(L"<Hackmap>: Unload for unknown warden being active.", 8);
}

void __declspec(naked) CallWardenModPatch_ASM()
{
	__asm {
		mov eax, [p_D2CLIENT_pWardenInterface];
		mov eax, [eax];
		cmp fWardenAction, 0;
		jz outcode;
		cmp fSafeWardenMod, 0;
		jz unloadmyself;
outcode:
		ret;
unloadmyself:
		push eax;
		call ShowUnloadMessage;

		// pop eax, pop eax, ret, int 3
		push 0xccc35858;		// prepare code for FreeLibrary returning
		jmp CommonUnloadMyself_ASM;
	}
}

#if 0
extern DWORD __stdcall GlobalGetOriginalData(DWORD);


void __declspec(naked) AntiDetectionPatch64_1_ASM()
{
	__asm {
		pushad;
		push eax;
		call GlobalGetOriginalData;
		mov [esp]I386Registers.eax, eax;
		popad;
		mov [ebp-0x20], eax; // old code
		ret;
	}
}

void __declspec(naked) AntiDetectionPatch64_2_ASM()
{
	__asm {
		pushad
		push ecx;
		call GlobalGetOriginalData;
		mov [esp]I386Registers.eax, eax;
		popad;
		mov ecx, eax;
		mov [ebp-0x24], ecx; // old code
		ret;
	}
}

void __declspec(naked) AntiDetectionPatch65_1_ASM()
{
	__asm {
		pushad;
		push eax;
		call GlobalGetOriginalData;
		mov [ebp-0x20], eax; // old code

		call D2CLIENT_GetGetItemFromListEntry;
		push eax;
		call GlobalGetOriginalData;
		mov [esp]I386Registers.eax, eax;
		popad;
		mov edi, eax;
		ret;
	}
}

void __declspec(naked) AntiDetectionPatch65_2_ASM()
{
	__asm {
		pushad;
		push eax;
		call GlobalGetOriginalData;
		mov [esp]I386Registers.eax, eax;
		popad;
		mov esi, eax;
		mov [ebp-0x1c], eax;
		ret;
	}
}

void __declspec(naked) AntiDetectionPatch65_3_ASM()
{
	__asm {
		pushad;
		push eax;
		call GlobalGetOriginalData;
		mov [esp]I386Registers.eax, eax;
		popad;
		mov [ebp-0x24], eax; // old code
		ret;
	}
}
#endif

BYTE fVersionCheckingDllAction;
BYTE fExtraworkDllAction = 1;
HMODULE __stdcall SuspiciousDLLPatch(BYTE flag, LPCSTR lpDllFileName)
{
	if(fGameInitDone)
		D2CLIENT_PrintGameStringAtTopLeft(L"WARNING!! Suspicious DLL is loading.", 8);

	if (flag == 0)
		return (*p_BNCLIENT_fnLoadLibraryA)(lpDllFileName);
	if(fGameInitDone)
		D2CLIENT_PrintGameStringAtTopLeft(L"Hackmap is going to unload itself.", 8);
	if (flag == (BYTE)-1)
	{
		char szPath[MAX_PATH];
		strcpy(szPath, lpDllFileName);
		strcat(szPath, ".bak");
		CopyFileA(lpDllFileName, szPath, FALSE);
	}
	return 0;
}

HMODULE __declspec(naked) __stdcall SuspiciousDLLPatch_ASM()
{
	__asm
	{
		push [esp+4];
		push eax;
		call SuspiciousDLLPatch;
		test eax, eax;
		jz unloadmyself;
		ret 4;
unloadmyself:
		add dword ptr [esp], 1;	// adjust return address
		push hInstDLL;			// parameter of FreeLibrary
		// d2loader patch LoadLibraryA in BNCLIENT.DLL for his purpose.
		// we must let d2loader to load dll in case you are using it.
		mov eax, dword ptr [p_BNCLIENT_fnLoadLibraryA];
		push dword ptr [eax]; // return address of FreeLibrary
		push FreeLibrary;		// function to call
		ret;					// call FreeLibrary to unload myself
	}
}

HMODULE __declspec(naked) __stdcall VersionCheckingPatch_ASM(LPCSTR lpExtraWorkFileName)
{
	__asm
	{
		movsx eax, fVersionCheckingDllAction;
		jmp SuspiciousDLLPatch_ASM;
	}
}

HMODULE __declspec(naked) __stdcall ExtraWorkPatch_ASM(LPCSTR lpExtraWorkFileName)
{
	__asm
	{
		movsx eax, fExtraworkDllAction;
		jmp SuspiciousDLLPatch_ASM;
	}
}

void __fastcall GamePacketReceivedIntercept(BYTE* aPacket, DWORD aLength)
{
	if(fBackToTown && aLength > 6 && *(WORD*)&aPacket[0] == 0x251 && *(WORD*)&aPacket[6] == 0x3B)
	{
		ResetPacketRecvIntercept();
		BYTE castMove[9] = {0x13};
		*(DWORD*)&castMove[1] = 2;
		*(DWORD*)&castMove[5] = *(DWORD*)&aPacket[2]; // portal ID
		D2NET_SendPacket(sizeof(castMove), 0, castMove);
	}
}

//////////////////////////////////////////////////////////////////////
// GamePacketReceivedSTUB()
// -------------------------------------------------------------------

// before call orignal code
// bl = packet number
// esi = length
// edi = pointer to packet
// free register before pushad: eax
//////////////////////////////////////////////////////////////////////
void __declspec(naked) GamePacketReceivedInterceptPatch_ASM()
{
	__asm {
		mov eax, esi; // save length

		// original code
		movzx esi, bl;
		mov ebp, esi
		shl ebp, 1
		add ebp, esi

		pushad;
		// Call our clean c function
		mov edx, eax;
		mov ecx, edi;
		call GamePacketReceivedIntercept;
		// Return to game
		popad;
		add dword ptr[esp], 1;
		ret;
	}
}

BYTE fChangingAct;
void __declspec(naked) ChangeActPatch1_ASM()
{
	__asm {
		pop eax;
		push esi;
		xor esi, esi;
		cmp fChangingAct, 0;
		mov fChangingAct, 0;
		jmp eax;
	}
}

void __declspec(naked) ChangeActPatch2_ASM()
{
	__asm {
		mov fChangingAct, 1;
		ret;
	}
}


// Locale

#define		KEY_CODE_COPY			0x03
#define		KEY_CODE_PASTE			0x16
#define		KEY_CODE_CUT			0x18
#define		KEY_CODE_ENTER			'\r'

#define EDITBOX_MAX_CHAR_COUNT		196
void D2UnicodeFix(LPWSTR lpText, DWORD * dwPos)
{
	DWORD len, i, j;
	WORD  char1, char2;
	WORD  uchar;
	BYTE  mbchar[2];
	DWORD	dwOldPos;
	DWORD	dwNewPos;

	if (!lpText) return;
	len = wcslen(lpText);
	if (dwPos) dwOldPos = *dwPos;
	else dwOldPos = 0;
	if (len >= 2) {
		dwNewPos = -1;
		for (i=0, j = 0; i < len; i++) {
			char1 = lpText[i];
			char2 = lpText[i+1];
			if (i == dwOldPos) {
				dwNewPos = j;
			}
			//a non-english character
			if (!HIBYTE(char1) && (char1) & 0x80 && char1 != 0xff && LOBYTE(char2)) {
				mbchar[0] = LOBYTE(char1);
				mbchar[1] = LOBYTE(char2);
				if (MultiByteToWideChar(CP_ACP, 0, (char *)mbchar, sizeof(mbchar), &uchar, 1)) {
					lpText[j++] = uchar;
					i++;
					if (i == dwOldPos) {
						dwNewPos = j-1;
					}
				} else {
					lpText[j++] = char1;
				}
			} else {
				lpText[j++] = char1;
			}
		}
		if (dwNewPos == (DWORD)-1) {
			dwNewPos = j;
		}
		lpText[j] = 0;
	} else {
		dwNewPos = dwOldPos;
	}
	if (dwPos) *dwPos = dwNewPos;
	return;
}

void D2UnicodeFix2(LPWSTR lpText)
{
	if (lpText) {
		size_t LEN = wcslen(lpText);
		for (size_t i = 0; i < LEN; i++)
		{
			if (lpText[i] == 0xf8f5) // Unicode 'y'
				lpText[i] = 0xff; // Ansi 'y'
		}
	}
}

int MyMultiByteToWideChar(
						UINT CodePage,         // code page
						DWORD dwFlags,         // character-type options
						LPCSTR lpMultiByteStr, // string to map
						int cbMultiByte,       // number of bytes in string
						LPWSTR lpWideCharStr,  // wide-character buffer
						int cchWideChar        // size of buffer
						)
{
	int r = MultiByteToWideChar(CodePage, dwFlags, lpMultiByteStr, cbMultiByte, lpWideCharStr, cchWideChar);
	D2UnicodeFix2(lpWideCharStr);
	return r;
}

void EditDeleteSelect(D2EditBox *hWnd)
{
	DWORD dwStart;
	DWORD len, i, j;

	if (hWnd->dwSelectStart == (DWORD)-1) return;
	if (hWnd->dwSelectStart == hWnd->dwSelectEnd) return;
	if (hWnd->dwSelectStart > hWnd->dwSelectEnd) {
		dwStart = hWnd->dwSelectEnd;
		len = hWnd->dwSelectStart - dwStart;
	} else {
		dwStart = hWnd->dwSelectStart;
		len = hWnd->dwSelectEnd - dwStart;
	}
	hWnd->dwSelectStart = (DWORD)-1;
	hWnd->dwSelectEnd = 0;
	i = dwStart;
	j = dwStart + len;
	while (1) {
		if (!hWnd->text[j]) break;
		hWnd->text[i++] = hWnd->text[j++];
	}
	hWnd->text[i] = 0;
	if (hWnd->dwCursorPos > dwStart && hWnd->dwCursorPos < dwStart + len) {
		hWnd->dwCursorPos = dwStart;
	} else if (hWnd->dwCursorPos >= dwStart+len) {
		hWnd->dwCursorPos -= len;
	}
	return;
}

void EditInsertChar(D2EditBox *hWnd, BYTE bKeyCode)
{
	DWORD len;
	LPWSTR	lpText;
	DWORD	i;

	lpText = (LPWSTR)(hWnd->text);
	len = wcslen(lpText);
	if (hWnd->dwCursorPos > len) {
		hWnd->dwCursorPos = len;
	}
	for (i=len; i >= hWnd->dwCursorPos && (i >= 0); i--) {
		lpText[i+1] = lpText[i];
	}
	lpText[hWnd->dwCursorPos] = (WORD)bKeyCode;
	hWnd->dwCursorPos++;
	D2UnicodeFix(hWnd->text, &hWnd->dwCursorPos);
	D2WIN_FontStuff_1_STUB(hWnd);
	return;
}
HANDLE hD2LocaleMPQ;
BOOL FontFilePatch(LPSTR lpText)
{
	if (!hD2LocaleMPQ) return FALSE;
	static  char const * font_replace_list[] = { 
		"fontingamechat", 
			"fontformal10", 
			NULL 
	};
//	static  char const * font_target_path = "data\\local\\font\\chi";
	static  char const * font_target_path = "data\\local\\font\\d2locale";
	static  char const * font_tbl_suffix = ".tbl";
	char	name[MAX_PATH];
	char	* p;
	BOOL	tbl;
	int	i;

	if (!lpText) return FALSE;
	p = strrchr(lpText, '\\');
	if (p) {
		strcpy(name, p+1);
	}
	p = strstr(name, font_tbl_suffix);
	if (p) {
		tbl = TRUE;
		*p = 0;
	} else {
		tbl = FALSE;
	}
	for (i=0; font_replace_list[i]; i++) {
		if (!lstrcmpi(name, font_replace_list[i])) {
			sprintf (name, "%s\\%s", font_target_path, font_replace_list[i]);
			if (tbl) {
				strcat(name, font_tbl_suffix); 
			}
			strcpy(lpText, name);
			return TRUE;
		}
	}
	return FALSE;
}

DWORD __fastcall D2WIN_DrawText2Patch(LPWSTR lpText, int x, int y, DWORD u1, int nColor, DWORD u2)
{
//	LPCWSTR lpVerText = L"v 1.11";
//	if (!wcscmp(lpText, lpVerText)) {
//		LPWSTR lpMyText = L"sting's hackmap loaded";
//		D2WIN_DrawText2(lpMyText, x, y-15, u1, nColor, u2);
//	}

	if (tToggleUseCustomFont.flag)
		D2UnicodeFix(lpText, NULL);
	return D2WIN_DrawText2(lpText, x, y, u1, nColor, u2);
}

BYTE bInitMyFont;
BYTE fInstallPatchs2;
FontInfo_t myFont;
BOOL InitializeMyFont()
{
	if (!myFont.hFontHandle) {
		const DWORD selFont = 13;
		DWORD oldfont = D2WIN_SetTextSize(1);
		FontInfo_t tmpFont;
		memcpy(&tmpFont, &D2WIN_FontTable[selFont], sizeof(FontInfo_t));
		memset(&D2WIN_FontTable[selFont], 0, sizeof(FontInfo_t));
		bInitMyFont=1;
		D2WIN_SetTextSize(selFont);
		bInitMyFont=0;
		memcpy(&myFont, &D2WIN_FontTable[selFont], sizeof(FontInfo_t));
		memcpy(&D2WIN_FontTable[selFont], &tmpFont, sizeof(FontInfo_t));
		D2WIN_SetTextSize(oldfont);
	}
	return myFont.hFontHandle != 0;
}
void ReleaseMyFont()
{
	if (myFont.hFontHandle) {
		D2WIN_FreeFontHandle(myFont.hFontHandle);
		FOG_FreePoolMemory(myFont.hMemHandle1, __FILE__, 0x135, 0);
		memset(&myFont, 0, sizeof(myFont));
	}
}

DWORD __fastcall D2Win_InitializeFontTablePatch(DWORD u1, LPSTR lpText, DWORD u2, LPCSTR file, DWORD line)
{
	if (bInitMyFont)
		FontFilePatch(lpText);
	return D2WIN_InitializeFontTable(lpText, line, file);
}


DWORD __fastcall D2Win_InitializeFontPatch(int fontnum, LPSTR lpText, DWORD dwSize)
{
	if(!fInstallPatchs2) {
		InstallPatchs2();
	}

	DWORD ret;
	ret = D2WIN_InitializeFont(lpText, dwSize);
	if (bInitMyFont)
		FontFilePatch(lpText);
	return ret;
}


void __fastcall DrawTextWithMyFont(wchar_t * pszwText, int x, int y, int nColor, int unknown, int unknown2)
{
	if (tToggleUseCustomFont.flag && (myFont.hFontHandle || InitializeMyFont())) {
		FontInfo_t tmpFont;
		memcpy(&tmpFont, &D2WIN_FontTable[D2WIN_CurrentFont], sizeof(FontInfo_t));
		memcpy(&D2WIN_FontTable[D2WIN_CurrentFont], &myFont, sizeof(FontInfo_t));
		D2WIN_DrawText(pszwText, x, y, nColor, unknown);
		memcpy(&D2WIN_FontTable[D2WIN_CurrentFont], &tmpFont, sizeof(FontInfo_t));
	}
	else
		D2WIN_DrawText(pszwText, x, y, nColor, unknown);
}

inline
BOOL IsInGameChatting(wchar_t *pszwText)
{
	return pszwText && ((pszwText[0] == 0xff && pszwText[1] == L'c' && pszwText[2] == L'4' && wcschr(pszwText, L':') != NULL) ||
		wcsstr(pszwText, L"whisper"));
}

inline
BOOL IsInGamePrivateMessage(wchar_t *pszwText)
{
	wchar_t *pe = wcschr(pszwText, L':');
	if (pe > pszwText && *(--pe) == L')') {
		--pe;
		for (wchar_t *ps = pszwText; ps < pe; ps++) {
			if (ps[0] == L'(' && ps[1] == L'*')
				return TRUE;
		}
	}
	return FALSE;
}

void __fastcall DrawTextInGameWithMyFont(wchar_t * pszwText, int x, int y, int nColor, int unknown, int unknown2)
{
	if (tToggleUseCustomFont.flag && (IsInGameChatting(pszwText) || (nColor==2&&IsInGamePrivateMessage(pszwText)) ))
		DrawTextWithMyFont(pszwText, x, y, nColor, unknown, unknown2);
	else
		D2WIN_DrawText(pszwText, x, y, nColor, unknown);
}

void __fastcall DrawTextInChannelWithMyFont(wchar_t * pszwText, int x, int y, int nColor, int unknown, int unknown2)
{
	if (x==0x1c && pszwText && (pszwText[3] == L'<' || wcsstr(pszwText, L"whisper")))
		DrawTextWithMyFont(pszwText, x, y, nColor, unknown, unknown2);
	else
		D2WIN_DrawText(pszwText, x, y, nColor, unknown);
}

void __declspec(naked) DrawTextInChannelWithMyFontPatch_ASM()
{
	__asm {
		int 3; // TODO: check if parameters are correct
		pop ecx // return address
		pop edx // parameter 2
		push ecx // push return address
		mov ecx, eax
		jmp DrawTextInChannelWithMyFont
	}
}

void __declspec(naked) DrawTextInChannelWithMyFontPatch2_ASM()
{
	__asm {
		int 3; // TODO: check if parameters are correct
		pop ecx // return address
		pop edx // parameter 2
		push ecx // push return address
		mov ecx, eax
		jmp DrawTextWithMyFont
	}
}

DWORD __fastcall ChannelEnterCharPatch(D2EditBox *hWnd, BYTE bKeyCode)
{
	DWORD	ret;
	LPWSTR	lpText;
	DWORD i, j, len;
	WORD  char1, char2;
	WORD  uchar;
	BYTE	mbchar[2];
	DWORD	dwPos;
	HGLOBAL hGlobal;
	LPSTR  lpStr;

	lpText = (LPWSTR)(hWnd->text);
	len = wcslen(lpText);
	if (!len) memset( hWnd->text, 0, sizeof(hWnd->text) );
	if (hWnd->dwCursorPos > len) hWnd->dwCursorPos = len;
	if (hWnd->dwCursorPos > 0) {
		char1 = lpText[hWnd->dwCursorPos-1];
		if (!HIBYTE(char1) && (char1) & 0x80 && char1 != 0xff) {
			mbchar[0] = LOBYTE(char1);
			mbchar[1] = bKeyCode;
			if (MultiByteToWideChar(CP_ACP, 0, (char *)mbchar, sizeof(mbchar), &uchar, 1)) {
				lpText[hWnd->dwCursorPos-1] = uchar;
				return TRUE;
			}
		}
	}
	if (bKeyCode == KEY_CODE_PASTE) {
		ret = D2WIN_AddEditBoxChar(hWnd, bKeyCode);
		dwPos = hWnd->dwCursorPos;
		D2UnicodeFix(lpText, &dwPos);
		hWnd->dwCursorPos = dwPos;
		return ret;
	} else if (bKeyCode == KEY_CODE_COPY || bKeyCode == KEY_CODE_CUT) {
		DWORD dwStart;
		DWORD n;

		if (hWnd->dwSelectStart == (DWORD)-1) return FALSE;
		if (hWnd->dwSelectStart == hWnd->dwSelectEnd) return FALSE;
		if (hWnd->dwSelectStart > hWnd->dwSelectEnd) {
			dwStart = hWnd->dwSelectEnd;
			len = hWnd->dwSelectStart - dwStart;
		} else {
			dwStart = hWnd->dwSelectStart;
			len = hWnd->dwSelectEnd - dwStart;
		}
		if (!OpenClipboard(NULL)) return FALSE;
		EmptyClipboard();
		hGlobal = GlobalAlloc(GMEM_MOVEABLE, (len+1) * 2); 
		if (hGlobal && (lpStr = (LPSTR)GlobalLock(hGlobal))) {
			n = WideCharToMultiByte(CP_ACP, 0, lpText + dwStart, len, lpStr, (len+1)*2, NULL, NULL);
			lpStr[n] = 0;
			GlobalUnlock(hGlobal);
			SetClipboardData(CF_TEXT, hGlobal);
		}
		CloseClipboard();
		if (hGlobal) GlobalFree(hGlobal);
		if (bKeyCode == KEY_CODE_CUT) EditDeleteSelect(hWnd);
		return TRUE;
	}
	if (bKeyCode >= ' ') {
		LPWSTR lpTmp;
		DWORD	dwNewPos;

		EditDeleteSelect(hWnd);
		/*
		EditInsertChar(hWnd, bKeyCode);
		return TRUE;
		*/
		lpTmp = (LPWSTR)malloc((len +1) *2 * sizeof(WORD));
		dwNewPos = (DWORD)-1;
		for (i=j=0; i < len; i++) {
			if (i == hWnd->dwCursorPos) {
				dwNewPos = j;
			}
			if (j >= EDITBOX_MAX_CHAR_COUNT) break;
			uchar = lpText[i];
			char2 = HIBYTE(uchar);
			if (char2) {
				if (WideCharToMultiByte(CP_ACP, 0, &uchar, 1, (char *)mbchar, 2, NULL, NULL)) {
					lpTmp[j++] = mbchar[0];
					lpTmp[j++] = mbchar[1];
				} else {
					lpTmp[j++] = uchar;
				}
			} else {
				lpTmp[j++] = uchar;
			}
		}
		if (dwNewPos == (DWORD)-1) {
			dwNewPos = j;
		}
		hWnd->dwCursorPos = dwNewPos;
		lpTmp[j] = 0;
		wcscpy(lpText, lpTmp);
		/*
		if (WideCharToMultiByte(CP_ACP, 0, lpText, len+1, lpTmp, (len+1)*2, NULL, NULL)) {
		len = strlen(lpTmp);
		if (len >= EDITBOX_MAX_CHAR_COUNT ) len = EDITBOX_MAX_CHAR_COUNT;
		for (i=0; i < len; i++) {
		lpText[i] = (BYTE)lpTmp[i];
		}
		lpText[i] = 0;
		}
		*/
		free(lpTmp);
		ret = D2WIN_AddEditBoxChar(hWnd, bKeyCode);
		if ((bKeyCode & 0x80) && (bKeyCode != 0xff)) {
			if (hWnd->dwCursorPos) {
				char1 = hWnd->text[hWnd->dwCursorPos-1];
				if (!char1) char1 = bKeyCode;
				hWnd->text[hWnd->dwCursorPos-1] = 0xff;
				D2UnicodeFix(hWnd->text, &hWnd->dwCursorPos);
				hWnd->text[hWnd->dwCursorPos-1] = char1;
				D2WIN_FontStuff_1_STUB(hWnd);
				return ret;
			}
		}
		D2UnicodeFix(hWnd->text, &hWnd->dwCursorPos);
		D2WIN_FontStuff_1_STUB(hWnd);
		return ret;
	}
	ret = D2WIN_AddEditBoxChar(hWnd, bKeyCode);
	return ret;
}

DWORD __fastcall ChannelEnterCharPatch2(D2EditBox *hWnd, BYTE bKeyCode)
{
	DWORD	ret;
	//LPWSTR	lpText;
	//DWORD i, len;
	//LPSTR	lpTmp;

	//lpText = (LPWSTR)(hWnd->text);
	//len = wcslen(lpText);
	//if (bKeyCode == KEY_CODE_ENTER) {
	//	lpTmp = (LPSTR)malloc((len +1) *2 * sizeof(WORD));
	//	if (WideCharToMultiByte(CP_ACP, 0, lpText, len+1, (LPSTR)lpTmp, (len+1)*2, NULL, NULL)) {
	//		len = strlen(lpTmp);
	//		if (len >= EDITBOX_MAX_CHAR_COUNT ) len = EDITBOX_MAX_CHAR_COUNT;
	//		for (i=0; i < len; i++) {
	//			lpText[i] = (BYTE)lpTmp[i];
	//		}
	//		lpText[i] = 0;
	//	}
	//	free(lpTmp);
	//}
	ret = D2WIN_FontStuff_2_STUB(hWnd, bKeyCode);
	return ret;
}

void __declspec(naked) ChannelEnterCharPatch2_ASM()
{
	__asm {
		int 3
		mov ecx, eax
		mov edx, dword ptr [esp+4]
		call ChannelEnterCharPatch2
		ret 4
	}
}

LPWSTR __fastcall D2Lang_Win2Unicode2(LPWSTR lpUnicodeStr, LPCSTR lpWinStr, DWORD dwBufSize)
{
	char szStackTmp[1024];
	size_t len = strlen(lpWinStr);
	char *p2, *pHeapTmp;
	if (len < sizeof(szStackTmp)) {
		p2 = szStackTmp;
		pHeapTmp = NULL;
	} else {
		pHeapTmp = new char[len+1];
		p2 = pHeapTmp;
	}

	for (LPCSTR p = lpWinStr; *p; ++p) {
		if ((BYTE)*p == 0xc3) {
			*p2++ = *(++p)+0x40;
		} else if ((BYTE)*p == 0xc2) {
			*p2++ = *(++p);
		} else {
			*p2++ = *p;
		}
	}
	*p2 = '\0';

	MultiByteToWideChar(CP_ACP, 0, pHeapTmp ? pHeapTmp : szStackTmp, -1, lpUnicodeStr, dwBufSize);
	if (pHeapTmp) delete [] pHeapTmp;
	return lpUnicodeStr;
}

LPWSTR __fastcall D2Lang_Win2Unicode(LPWSTR lpUnicodeStr, LPCSTR lpWinStr, DWORD dwBufSize)
{
	MyMultiByteToWideChar(CP_ACP, 0, lpWinStr, -1, lpUnicodeStr, dwBufSize);
	return lpUnicodeStr;
}

LPCSTR __fastcall D2Lang_Unicode2Win(LPSTR lpWinStr, LPWSTR lpUnicodeStr, DWORD dwBufSize)
{
	WideCharToMultiByte(CP_ACP, 0, lpUnicodeStr, -1, lpWinStr, dwBufSize, NULL, NULL);
	return lpWinStr;
}

LPWSTR __fastcall D2Lang_Utf82Unicode(LPWSTR lpUnicodeStr, LPCSTR lpWinStr, DWORD dwBufSize)
{
	MultiByteToWideChar(CP_ACP, 0, lpWinStr, -1, lpUnicodeStr, dwBufSize);
	return lpUnicodeStr;
}

void __declspec(naked) IsPritableCharacterPatch_ASM()
{
	__asm {
		test cl, 0x80;
		jz oldcode;
		cmp cl, 0xff;
		jz oldcode;
		pop eax; // adjust esp
		mov eax, 1;
		ret;
oldcode:
		movzx ax, cl;
		cmp ax, 0x100
		ret;
	}
}

DWORD __fastcall D2LocaleGameChat(LPWSTR lpText, DWORD u1, DWORD u2)
{
	DWORD len;
	WORD  char1, char2;
	WORD  uchar;
	BYTE  mbchar[2];

	if (lpText) {
		len = wcslen(lpText);
		if (len >= 2) {
			char1 = lpText[len-2];
			char2 = lpText[len-1];
			//a non-english character
			if (!HIBYTE(char1) && (char1) & 0x80 && char1 != 0xff && LOBYTE(char2)) {
				mbchar[0] = LOBYTE(char1);
				mbchar[1] = LOBYTE(char2);
				if (MultiByteToWideChar(CP_ACP, 0, (char *)mbchar, sizeof(mbchar), &uchar, 1)) {
					lpText[len-2] = uchar;
					lpText[len-1] = 0;
					(*p_D2CLIENT_nTextLength)--;
				}
			}
		}
	}
	return D2WIN_ORD_27D7(lpText,u1,u2);
}

DWORD  __fastcall EnterChatPatch(DWORD u1, LPWSTR lpText, DWORD u2, DWORD u3, DWORD u4)
{
	D2UnicodeFix(lpText, NULL);
	return D2WIN_ORD_2743(u1, lpText, u2, u3, u4);
}

void __stdcall D2MultiByteFix(LPSTR str)
{
	struct tagChat {
		DWORD _1[7];
		char txt[1];
	};
	tagChat *pc = (tagChat*)str;

	char *p2 = pc->txt + strlen(pc->txt) + 1;
	for (LPCSTR p = p2; *p; ++p) {
		if ((BYTE)*p == 0xc3) {
			*p2++ = *(++p)+0x40;
		} else if ((BYTE)*p == 0xc2) {
			*p2++ = *(++p);
		} else {
			*p2++ = *p;
		}
	}
	*p2 = '\0';
}

void __declspec(naked) D2MultiByteFixPatch_ASM()
{
	__asm {
		mov eax, [p_BNCLIENT_ChatMessage];
		mov [eax], ebp;
		push ebp;
		call D2MultiByteFix;
		ret;
	}
}

struct InventoryLocation {
	int invlocation;
	short xstart;
	short ystart;
	BYTE xmaxcell;
	BYTE ymaxcell;
	BYTE xresolution;
	BYTE yresolution;
};

inline BOOL PtInRect(const InventoryLocation& loc, short x, short y)
{
	if (x > loc.xstart && x < loc.xstart+loc.xresolution*loc.xmaxcell) {
		if (y > loc.ystart && y < loc.ystart+loc.yresolution*loc.ymaxcell) {
			return TRUE;
		}
	}
	return FALSE;
}

inline
InventoryLocation* GetInVentoryLocationInfo(short x, short y, int loctype)
{
	static InventoryLocation locations[] = {
		{0, 420, 315, 10, 4, 29, 29}, // Inventory
		{4, 155, 142, 6, 8, 29, 29}, // Stash
		{3, 210, 210, 3, 4, 29, 29}, // Cube
	};
	return (x < D2GetScreenSizeX()/2) ? &locations[0] : &locations[loctype];
}

void __stdcall RButtonUpHandlerPatch(D2MSG *pmsg)
{
	if (tToggleRightClickSwap.flag) {
		int loctype = 0;
		if (D2CLIENT_GetUiVar(UIVAR_STASH))
			loctype = 1;
		else if (D2CLIENT_GetUiVar(UIVAR_CUBE))
			loctype = 2;
		if (pmsg->message == WM_RBUTTONUP && loctype) {
			UnitAny *pla = D2CLIENT_GetPlayerUnit();
			UnitAny *item = D2COMMON_GetCursorItem(pla->pInventory);
			if (item && item->pItemData->nLocation2 == 0xff) {
				InventoryLocation *invloc = GetInVentoryLocationInfo(pmsg->xpos, pmsg->ypos, loctype);
				if (invloc) {
					DWORD u5 = D2COMMON_10409(pla, invloc->invlocation, D2CLIENT_GetUnknownFlag());
					for (int x = 0; x < invloc->xmaxcell; ++x) {
						for (int y = 0; y < invloc->ymaxcell; ++y) {
							int xpos = invloc->xstart + x*invloc->xresolution;
							int ypos = invloc->ystart + y*invloc->yresolution;
							int u6 = 0;
							int count = 0;
							// reset mouse point
							SendMessage(pmsg->hwnd, WM_MOUSEMOVE, pmsg->wParam, MAKELONG(xpos, ypos));
							D2COMMON_10247(pla->pInventory, item, *p_D2CLIENT_UnkU3, *p_D2CLIENT_UnkU4, u5, &u6, &count, invloc->invlocation);
							if (!count) {
								// insert item
								SendMessage(pmsg->hwnd, WM_LBUTTONDOWN, pmsg->wParam, MAKELONG(xpos, ypos));
								SendMessage(pmsg->hwnd, WM_LBUTTONUP, pmsg->wParam, MAKELONG(xpos, ypos));
								x = y = 1000; // break;
							}
						}
					}
					// restore
					SendMessage(pmsg->hwnd, WM_MOUSEMOVE, pmsg->wParam, pmsg->lParam);
				}
			}
		}
	}
	// old handler
//	D2CLIENT_RButtonUpHandler(pmsg);
}

void __declspec(naked) RButtonUpHandlerPatch_ASM()
{
	__asm {
		push [esp+8];
		call RButtonUpHandlerPatch;
//oldcode:
		mov eax, p_D2CLIENT_UnkU6;
		mov eax, [eax];
		ret;
	}
}

void __cdecl PackethandlerPatch(BYTE *cmdbuf, BYTE nPacketNum, void (__fastcall *fnOldHandler)(BYTE* cmdbuf))
{
	TCHAR szText[256];
	sprintf(szText, "recv packet 0x%x\n", nPacketNum);
	OutputDebugString(szText);
}

void __declspec(naked) PackethandlerPatch_ASM()
{
	// bl = packet number
	//edi = cmdbuf
	__asm {
	jz ret_fun

	push eax
	movzx eax, bl
	push eax
	push edi
	call PackethandlerPatch
	pop eax
	pop eax
	pop eax
	//old code
	mov ecx, edi
	jmp eax

ret_fun:
	ret
	}
}

void PatchPacketHandler(DWORD nPacketNum, DWORD fnNewHandler, DWORD len)
{
	const BYTE MAX_PACKET_NUM = 0xB0;
	if (nPacketNum < MAX_PACKET_NUM)
	{
		PacketHandler_t *pPacketHandler = (PacketHandler_t*)p_D2CLIENT_PacketHandlerTable;
		DWORD fnOldHandler = pPacketHandler[nPacketNum].fnHandler;
		PatchVALUE((DWORD)&pPacketHandler[nPacketNum].fnHandler, fnNewHandler, sizeof(DWORD));
	}
}

void __declspec(naked) CommonUnload_RecvCommand_Routine_ASM()
{
	__asm
	{
		pop ecx;
		test bl,bl;
		jnz unloadmyself
		jmp eax;
unloadmyself:
		push eax; // original handler address
		push ecx;

		// pop ecx, pop ecx, ret, int 3
		push 0xccc35959;		// prepare code for after FreeLibrary return
		push hInstDLL;			// parameter of FreeLibrary
		lea eax, [esp+4];		// load return address of FreeLibrary
		push eax;				// return address of FreeLibrary
		push FreeLibrary;		// function to call
		ret;					// call FreeLibrary to unload myself
	}
}

Patch_t aD2PacketHandlerPatchs[];
DWORD __stdcall RecvCommand_Patch(DWORD nPacketNum, int nPatchIndex)
{
	wchar_t szInfo[128];
	wsprintfW(szInfo, L"Hackmap has been unloaded due to seeing %02X packet\n", nPacketNum);
	OutputDebugStringW(szInfo);

	if (nPacketNum > 0 && fGameInitDone) {
		D2CLIENT_PrintGameStringAtTopLeft(szInfo, 8);
	}
	return *(DWORD*)aD2PacketHandlerPatchs[nPatchIndex].oldcode;
}

void __declspec(naked) RecvCommand_AE_Patch_ASM()
{
	__asm
	{
		//ecx = cmdbuf
		push ecx;
		push 0;
		push 0xAE;
		call RecvCommand_Patch;
		jmp CommonUnload_RecvCommand_Routine_ASM;
	}
}

void __declspec(naked) RecvCommand_AF_Patch_ASM()
{
	__asm
	{
		//ecx = cmdbuf
		push ecx;
		push 1;
		movzx eax, bl;
		push eax;
		call RecvCommand_Patch;
		jmp CommonUnload_RecvCommand_Routine_ASM;
	}
}

void PossibleHackDetectionPath()
{
	wchar_t *szInfo = L"Hackmap has been unloaded due to seeing somebody trying to detect hacks\n";
	OutputDebugStringW(szInfo);
	if (fGameInitDone) {
		D2CLIENT_PrintGameStringAtTopLeft(szInfo, 8);
	}
}

void __declspec(naked) PossibleHackDetectionPath_ASM()
{
	__asm
	{
		sub dword ptr [esp], 5;
		call PossibleHackDetectionPath;

		// pop ecx, ret, int 3
		push 0xccccc359;		// prepare code for after FreeLibrary return
		push hInstDLL;			// parameter of FreeLibrary
		lea eax, [esp+4];		// load return address of FreeLibrary
		push eax;				// return address of FreeLibrary
		push FreeLibrary;		// function to call
		ret;					// call FreeLibrary to unload myself
	}
}

//void __stdcall LButtonDownHandlerPatch(D2MSG *pmsg)
//{
//	D2CLIENT_LButtonDownHandler(pmsg);
//}

#pragma warning(disable : 4786 )
#include <bitset>
#include <map>
#include <vector>
#include <algorithm>
struct MinimapCell {
	short xpos;
	short ypos;
	short cellno;
};
typedef std::vector<MinimapCell> LevelMinimapObjectList;
typedef std::map<int, LevelMinimapObjectList> MinimapObjectList;
MinimapObjectList anMinimapCells;
const int nMaxMinimapLevelNo = 140;
const int nMaxMinimapCellNo = 2000;
BYTE nMinimapCellCol = 12;// green:129, yellow:12;
BYTE nMinimapSize = 1;
int nCurrLevelNo;
const LevelMinimapObjectList *pCurrLevelObjects;
std::bitset<nMaxMinimapLevelNo*nMaxMinimapCellNo> anMinimapCellMasks;


void ResetMinimapCells()
{
	nCurrLevelNo = -1;
	anMinimapCells.clear();
	if( nMinimapSize == 0 || nMinimapSize > 8 )
		nMinimapSize = 1;
}

BOOL TestMinimapCell(int cellno, int lvlno, DrlgLevel *pDrlgLevel)
{
	return (lvlno == 46 && pDrlgLevel->pDrlgMisc->nStaffTombLvl == cellno)
		|| (lvlno == pDrlgLevel->pDrlgMisc->nStaffTombLvl && cellno == 300)
		|| anMinimapCellMasks.test((lvlno-1)*nMaxMinimapCellNo+(cellno-1));
}

void AddMinimapCell(AutomapCell *cell, DrlgLevel *pDrlgLevel)
{
	int cellno = (short)cell->nCellNo;
	int lvlno = pDrlgLevel->nLevelNo;
	if (lvlno == 45) lvlno = 44; // Change Valley of Snakes to Lost City

	if (cellno < 0 ) cellno = -cellno;
	if (cellno > 0 &&
		cellno <= nMaxMinimapCellNo &&
		lvlno > 0 &&
		lvlno <= nMaxMinimapLevelNo &&
		TestMinimapCell(cellno, lvlno, pDrlgLevel))
//		anMinimapCellMasks.test((lvlno-1)*nMaxMinimapCellNo+(cellno-1)))
	{
		if ( (lvlno == 4 && cellno == 314)) { // cairn stone in stoney field
			MinimapObjectList::iterator it = anMinimapCells.find(lvlno);
			if (it != anMinimapCells.end()) {
				LevelMinimapObjectList::iterator oit = (*it).second.begin();
				LevelMinimapObjectList::iterator oend = (*it).second.end();
				for (; oit != oend; ++oit) {
					if ((*oit).cellno == cellno) return;
				}
			}
		}
		MinimapCell minicell = {(short)cell->xPixel, (short)cell->yPixel, (short)cellno};
		anMinimapCells[lvlno].push_back(minicell);
		nCurrLevelNo = -1;
	}
}

inline void CalcTargetPosition(POINT *ptPlayer, POINT *ptObject, POINT *ptLine)
{
	int xDistance = ptObject->x-ptPlayer->x;
	int yDistance = ptObject->y-ptPlayer->y;
	double xyDistance = sqrt((double)xDistance*xDistance + yDistance*yDistance);
	ptLine->x = (LONG)(ptPlayer->x + 8*nMinimapSize*xDistance/xyDistance);
	ptLine->y = (LONG)(ptPlayer->y + 8*nMinimapSize*yDistance/xyDistance);
}

void DrawMinimapCell(int xpos, int ypos, BYTE col)
{
	POINT ptObj;
	ScreenToAutomapRelative(&ptObj, xpos+D2CLIENT_ptAutomap.x, ypos+D2CLIENT_ptAutomap.y);
	if (pMinimapObjectCell) {
		DrawAutomapCell2(pMinimapObjectCell, ptObj.x, ptObj.y, col);
	}
	else {
		wchar_t temp[20] = {L'*'};
		ColourD2String(temp, col);
		D2DrawCenterText(6, temp, ptObj.x, ptObj.y, col);
	}

	POINT ptPlayer, ptLine;
	D2GetPlayerPosition(&ptPlayer);
	if(ptPlayer.x != ptObj.x && ptPlayer.y != ptObj.y) {
		CalcTargetPosition(&ptPlayer, &ptObj, &ptLine);
		D2GFX_DrawLine(ptPlayer.x, ptPlayer.y, ptLine.x, ptLine.y, col, -1);
	}
}

void ReCalcCoordinate(int& x, int& y)
{
	int x0 = D2GetScreenSizeX()/2;
	int y0 = (D2GetScreenSizeY()-48)/2;
	int x2 = x + (nMinimapSize-1)*(x-x0);
	if (x != x0)
		y = y0 + (x2-x0)*(y-y0)/(x-x0);
	else
		y = y + (nMinimapSize-1)*(y-y0);
	x = x2;
}

void DrawMinimapLevel(int lvlno)
{
	if (nCurrLevelNo != lvlno)
	{
		nCurrLevelNo = lvlno;
		MinimapObjectList::const_iterator cit = anMinimapCells.find(lvlno);
		if( cit != anMinimapCells.end() )
			pCurrLevelObjects = &cit->second;
		else
			pCurrLevelObjects = NULL;
	}
	if (pCurrLevelObjects)
	{
		const LevelMinimapObjectList& lvlobjs = *pCurrLevelObjects;
		int i, c;
		int xpos, ypos;
		c = lvlobjs.size();
		for( i = 0; i < c; i++ )
		{
			const MinimapCell& cell = lvlobjs[i];
			xpos = cell.xpos*10/D2CLIENT_nPtDivisor-D2CLIENT_ptOffset.x;
			ypos = cell.ypos*10/D2CLIENT_nPtDivisor-D2CLIENT_ptOffset.y;
			ReCalcCoordinate(xpos, ypos);
			DrawMinimapCell(xpos, ypos, nMinimapCellCol);
		}
	}
}
char *szLocaleMPQ;
BYTE fLocalizationSupport = 1;

#include "hnmconfig.cxx"
#include "d2patchs.cxx"

void KeepGameWindow()
{
	if (fWindowMode) {
		if(tToggleKeepGameWindow.flag) {
			InstallD2Patchs(aKeepGameWindowPatchs, aKeepGameWindowPatchs+ARRAYSIZE(aKeepGameWindowPatchs));
		} else {
			RemoveD2Patchs(aKeepGameWindowPatchs, aKeepGameWindowPatchs+ARRAYSIZE(aKeepGameWindowPatchs));
		}
	}
}

void ResetPacketRecvIntercept()
{
	fBackToTown = 0;
	RemoveD2Patchs(aPacketRecvPatchs, aPacketRecvPatchs+ARRAYSIZE(aPacketRecvPatchs));
}

void BackToTown()
{
	UnitAny *pla = D2CLIENT_GetPlayerUnit();
	if(TestPlayerInTown(pla)) return;

	fBackToTown = 1;
	InstallD2Patchs(aPacketRecvPatchs, aPacketRecvPatchs+ARRAYSIZE(aPacketRecvPatchs));

	BYTE castTP1[9] = {0x3C};
	*(DWORD*)&castTP1[1] = 0xDC;
	*(DWORD*)&castTP1[5] = 0xFFFFFFFF;
	D2NET_SendPacket(sizeof(castTP1), 0, castTP1);
	
	BYTE castTP2[5] = {0x0C};
	*(WORD*)&castTP2[1] = pla->pPos->targetx;
	*(WORD*)&castTP2[3] = pla->pPos->targety;
	D2NET_SendPacket(sizeof(castTP2), 0, castTP2);
}

void InitVars()
{
	memset(afMonsterCorpses, 1, sizeof(afMonsterCorpses));
	memset(afMissileCorpses, 1, sizeof(afMissileCorpses));
	memset(afMonsterDeathAnims, 1, sizeof(afMonsterDeathAnims));
	memset(anMonsterCorpseColors, 1, sizeof(anMonsterCorpseColors));
	memset(anItemColours, -1, sizeof(anItemColours));
	memset(anRuneColours, -1, sizeof(anRuneColours));
	memset(anMissileColours, -1, sizeof(anMissileColours));
}

PBYTE InitMinimapCellsConfig()
{
	PBYTE pMiniCells = (PBYTE)VirtualAlloc(NULL, anMinimapCellMasks.size(), MEM_COMMIT, PAGE_READWRITE);
	if (pMiniCells) {
		for (int i = 0; i < ARRAYSIZE(aConfigVars); i++) {
			if (!stricmp(aConfigVars[i].szName1, "MinimapCells") ) {
				aConfigVars[i].pVar = pMiniCells;
//				for (int j = 0; j < nMaxMinimapLevelNo-1; j++) {
//					*(pMiniCells+j*nMaxMinimapCellNo+j+1) = 1;
//				}
				return pMiniCells;
			}
		}
	}
	VirtualFree(pMiniCells, 0, MEM_RELEASE);
	return NULL;
}

void InitMiniCells(PBYTE pMiniCells)
{
	PBYTE ps = pMiniCells;
	PBYTE pe = pMiniCells+anMinimapCellMasks.size();
	while (ps < pe) {
		ps = std::find(ps, pe, 1);
		if (ps != pe) {
			anMinimapCellMasks.set(ps-pMiniCells);
			++ps;
		}
	}
}

BOOL InitD2LocaleMPQ()
{
	char	tmp[MAX_PATH];
	char * filename = szLocaleMPQ ? szLocaleMPQ : "D2Locale.MPQ";
	char *lpFile = filename;

	BOOL fFileNameOnly = strrchr(filename, '\\') == NULL;
	if (fFileNameOnly) {
		GetModuleFileName( NULL, tmp, MAX_PATH);
		strcpy( strrchr( tmp,'\\')+1, filename);
		lpFile = tmp;
	}
	if (!STORM_OpenArchive( lpFile, 0x10000, 2, &hD2LocaleMPQ) ||!hD2LocaleMPQ) {
		if (fFileNameOnly) {
			strcpy(GetMyFileNameStrrchr( tmp, '\\'), filename);
			lpFile = tmp;
		}
		if (!STORM_OpenArchive( lpFile, 0x10000, 2, &hD2LocaleMPQ) || !hD2LocaleMPQ) {
			return FALSE;
		}
	}

	return hD2LocaleMPQ != NULL;
}

void RemoveD2LocaleMPQ()
{
	if (hD2LocaleMPQ) {
		STORM_CloseArchive(hD2LocaleMPQ);
		hD2LocaleMPQ = NULL;
	}
}

void GetGameWindowMode()
{
	WINDOWINFO wi;
	HWND hwnd = D2GFX_GetHwnd();
	if (hwnd && GetWindowInfo(hwnd, &wi)) {
		if ( (wi.dwStyle & WS_CAPTION) && (wi.dwExStyle& WS_EX_WINDOWEDGE) ) {
			fWindowMode = 1;
		}
		else
			fWindowMode = 0;
	}
	else {
		LPSTR pszCmdLine = GetCommandLine();
		LPSTR p;
		for ( p = pszCmdLine; (p=strchr(p, ' ')) != NULL; p++) {
			if ((p[1] == '-') &&
				(p[2] == 'w' || p[2] == 'W') &&
				(p[3] == ' ' || p[3] == '\0')) {
				fWindowMode = 1;
				break;
			}
		}
	}
}

BOOL InstallPatchs()
{
	if (!RelocD2Ptrs((DWORD *)&pD2PtrsListStart, (DWORD *)&pD2PtrsListEnd))
	{
#ifdef _DEBUG
		OutputDebugString("Unable to relocate D2 pointers\n");
#endif
		return FALSE;
	}

	int i;
	DWORD chksum = 0;
	for (i = 0; i < ARRAYSIZE(aD2PatchItems); i++) {
		chksum += RelocD2Patchs(aD2PatchItems[i].patch, aD2PatchItems[i].patch+aD2PatchItems[i].num);
	}

#ifdef _DEBUG
	static DWORD chksumfix = chksum;
#else
	if (chksum != 0x37464654)
		return FALSE;
#endif

	InitVars();

	PBYTE p = InitMinimapCellsConfig();
	if (!p)
	{
#ifdef _DEBUG
		OutputDebugString("Unable to initialize mini-map cells configuration\n");
#endif
		return FALSE;
	}

	__try {
		LoadConfig(aConfigVars,ARRAYSIZE(aConfigVars));
		nWardenSigNum = LoadWardenModSignatures(pWardenSig);
		InitMiniCells(p);
	}__finally {
		VirtualFree(p, 0, MEM_RELEASE);
	}

	//TODO: remove this after complete localization support
	fLocalizationSupport = 0;

	for(i = 0; i < ARRAYSIZE(aD2PatchItems); i++) {
		SaveD2Patchs(aD2PatchItems[i].patch, aD2PatchItems[i].patch+aD2PatchItems[i].num);
		if(!aD2PatchItems[i].fInitOnDemand)
			InstallD2Patchs(aD2PatchItems[i].patch, aD2PatchItems[i].patch+aD2PatchItems[i].num);
	}

	if (fLocalizationSupport) {
		InitD2LocaleMPQ();
		InstallD2Patchs(aD2LocalePatchs, aD2LocalePatchs+ARRAYSIZE(aD2LocalePatchs));
	}

	if (fAutomapPartyDefault != -1) D2CLIENT_SetAutomapParty(fAutomapPartyDefault);
	if (fAutomapNamesDefault != -1) D2CLIENT_SetAutomapNames(fAutomapNamesDefault);

	if (GetModuleHandle("D2LAUNCH.DLL")) {
		InstallPatchs2();
	}

	GetGameWindowMode();
	KeepGameWindow();

	return TRUE;
}

void RemovePatchs()
{
#ifdef ENABLE_CATCH_EXECEPTION
	SetDbgUnexpectedHandler(FALSE);
#endif

	GameEndPatch();

	if (pWardenSig)
		delete [] pWardenSig;

	for(int i = 0; i < ARRAYSIZE(aD2PatchItems); i++) {
		RemoveD2Patchs(aD2PatchItems[i].patch, aD2PatchItems[i].patch+aD2PatchItems[i].num);
		DeleteD2Patchs(aD2PatchItems[i].patch, aD2PatchItems[i].patch+aD2PatchItems[i].num);
	}

	ReleaseMyFont();

	if(fInstallPatchs2) {
		RemoveD2Patchs(aD2Patchs2, aD2Patchs2+ARRAYSIZE(aD2Patchs2));
		DeleteD2Patchs(aD2Patchs2, aD2Patchs2+ARRAYSIZE(aD2Patchs2));

		if (fLocalizationSupport) {
			RemoveD2Patchs(aD2LocalePatchs2, aD2LocalePatchs2+ARRAYSIZE(aD2LocalePatchs2));
			DeleteD2Patchs(aD2LocalePatchs2, aD2LocalePatchs2+ARRAYSIZE(aD2LocalePatchs2));
		}
		fInstallPatchs2 = 0;
	}
	RemoveD2LocaleMPQ();
}

void InstallPatchs2()
{
	if (!fInstallPatchs2) {
		fInstallPatchs2 = 1;
		DWORD chksum = RelocD2Patchs(aD2Patchs2, aD2Patchs2+ARRAYSIZE(aD2Patchs2));
		if (chksum == 0x00008800) {
			SaveD2Patchs(aD2Patchs2, aD2Patchs2+ARRAYSIZE(aD2Patchs2));
			InstallD2Patchs(aD2Patchs2, aD2Patchs2+ARRAYSIZE(aD2Patchs2));
		}

		if (fLocalizationSupport) {
			chksum = RelocD2Patchs(aD2LocalePatchs2, aD2LocalePatchs2+ARRAYSIZE(aD2LocalePatchs2));
			if (chksum == 0xff83cae8) {
				SaveD2Patchs(aD2LocalePatchs2, aD2LocalePatchs2+ARRAYSIZE(aD2LocalePatchs2));
				InstallD2Patchs(aD2LocalePatchs2, aD2LocalePatchs2+ARRAYSIZE(aD2LocalePatchs2));
			}
		}
	}
}
